--****************************************************************************
-- (c) Copyright IBM Corp. 2017 All rights reserved.
--
-- The following sample of source code ("Sample") is owned by International
-- Business Machines Corporation or one of its subsidiaries ("IBM") and is
-- copyrighted and licensed, not sold. You may use, copy, modify, and
-- distribute the Sample in any form without payment to IBM, for the purpose of
-- assisting you in the development of your applications.
--
-- The Sample code is provided to you on an "AS IS" basis, without warranty of
-- any kind. IBM HEREBY EXPRESSLY DISCLAIMS ALL WARRANTIES, EITHER EXPRESS OR
-- IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
-- MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. Some jurisdictions do
-- not allow for the exclusion or limitation of implied warranties, so the above
-- limitations or exclusions may not apply to you. IBM shall not be liable for
-- any damages you suffer as a result of using, copying, modifying or
-- distributing the Sample, even if IBM has been advised of the possibility of
-- such damages.
--*****************************************************************************

echo ********************************************************;
echo                                                         ;
echo  This script was generated                              ;
echo                                                         ;
echo    by db2mon.pl version 1.2.0                           ;
echo                                                         ;
echo    for DB2 version 9.7                                 ;
echo                                                         ;
echo    on Mon Apr 11 00:09:25 2022                          ;
echo                                                         ;
echo    with 30 seconds pause between collections  ;
echo    in db2mon.sql and db2mon_export.sql                  ;
echo    (0 seconds pause means script will wait for <ENTER>) ;
echo                                                         ;
echo  Changes to this script will be overwritten the next    ;
echo  time db2mon.pl is run.                                 ;
echo                                                         ;
echo  1. Connect to database                                 ;
echo  2. Ensure a user temporary tablespace already exists   ;
echo     e.g. 'db2 create user temporary tablespace utemp'   ;
echo  3. Run with CLP as in 'db2 -tvf db2mon.sql'            ;
echo                                                         ;
echo  You can also run with db2mon.sh, which connects to the ;
echo  database and creates the tablespace, etc. automatically;
echo                                                         ;
echo  Report starts at string 'REPORT STARTS HERE'.          ;
echo                                                         ;
echo ********************************************************;
echo                                                         ;
echo                               ;
echo ***************************** ;
echo Checking db2mon prerequisites ;
echo ***************************** ;
echo                               ;
with /* IBM_DB2MON */
utemp_check as ( 
  select count(*) utemp_count from syscat.tablespaces where datatype = 'U' ),
config_check as (
  select 
    cast(substr(name,1,20) as varchar(20)) name, 
    cast(substr(value,1,20) as varchar(20)) value
  from sysibmadm.dbcfg 
  where dbpartitionnum = current node and
    name in ('mon_req_metrics','mon_act_metrics','mon_obj_metrics') ),
req_check as (
  select value req_value from config_check where name = 'mon_req_metrics' ),
act_check as (
  select value act_value from config_check where name = 'mon_act_metrics' ),
obj_check as (
  select value obj_value from config_check where name = 'mon_obj_metrics' )
select t.prereq "db2mon Prerequisite", t.msg "Status"
from
  utemp_check,
  req_check,
  act_check,
  obj_check,
  table( values
    ( 'User temp tablespace? ', 
       case when utemp_count != 0 then 'OK (' || varchar(utemp_count) || ' defined)'  
       else '******** Missing - ensure user temp tablespace exists before running db2mon.sql' end ),
    ( 'MON_REQ_METRICS correct? ', 
       case when req_value in ('BASE','EXTENDED') then 'OK (currently ' || rtrim(req_value) || ')' 
       else '******** Needs to be BASE or EXTENDED to get full data collection' end ),
    ( 'MON_ACT_METRICS correct? ', case when act_value in ('BASE','EXTENDED') then 'OK (currently ' || rtrim(act_value) || ')' 
       else '******** Needs to be BASE or EXTENDED to get full data collection' end ),
    ( 'MON_OBJ_METRICS correct? ', case when obj_value in ('BASE','EXTENDED') then 'OK (currently ' || rtrim(obj_value) || ')' 
       else '******** Needs to be BASE or EXTENDED to get full data collection' end ) ) as t(prereq,msg);

/* IBM_DB2MON */ select cast(substr(current schema,1,24) as varchar(24)) as current_schema from sysibm.sysdummy1;

/* IBM_DB2MON */ drop table session.dbmcfg_start;
/* IBM_DB2MON */ drop table session.dbmcfg_end;
/* IBM_DB2MON */ declare global temporary table dbmcfg_start as ( select current timestamp ts,name, value, value_flags from sysibmadm.dbmcfg) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ declare global temporary table dbmcfg_end like session.dbmcfg_start on commit preserve rows not logged;
/* IBM_DB2MON */ drop table session.dbmcfg_diff;
/* IBM_DB2MON */ declare global temporary table dbmcfg_diff as ( select cast(null as integer) ts_delta, current timestamp ts,name, value, value_flags from sysibmadm.dbmcfg) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ create index session.idx_dbmcfg_start on session.dbmcfg_start (name);
/* IBM_DB2MON */ create index session.idx_dbmcfg_end on session.dbmcfg_end (name);
/* IBM_DB2MON */ drop table session.env_get_system_resources_start;
/* IBM_DB2MON */ drop table session.env_get_system_resources_end;
/* IBM_DB2MON */ declare global temporary table env_get_system_resources_start as ( select current timestamp ts,member, os_name, host_name, os_version, os_release, cpu_total, cpu_online, cpu_configured, cpu_speed, cpu_hmt_degree, memory_total, memory_free, cpu_load_short, cpu_load_medium, cpu_load_long, cpu_usage_total, swap_pages_in, swap_pages_out from table (sysproc.env_get_system_resources( ) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ declare global temporary table env_get_system_resources_end like session.env_get_system_resources_start on commit preserve rows not logged;
/* IBM_DB2MON */ drop table session.env_get_system_resources_diff;
/* IBM_DB2MON */ declare global temporary table env_get_system_resources_diff as ( select cast(null as integer) ts_delta, current timestamp ts,member, os_name, host_name, os_version, os_release, cpu_total, cpu_online, cpu_configured, cpu_speed, cpu_hmt_degree, memory_total, memory_free, cpu_load_short, cpu_load_medium, cpu_load_long, cpu_usage_total, swap_pages_in, swap_pages_out from table (sysproc.env_get_system_resources( ) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ create index session.idx_env_get_system_resources_start on session.env_get_system_resources_start (member);
/* IBM_DB2MON */ create index session.idx_env_get_system_resources_end on session.env_get_system_resources_end (member);
/* IBM_DB2MON */ drop table session.env_inst_info_start;
/* IBM_DB2MON */ drop table session.env_inst_info_end;
/* IBM_DB2MON */ declare global temporary table env_inst_info_start as ( select current timestamp ts,inst_name, num_dbpartitions, service_level, bld_level, ptf from sysibmadm.env_inst_info) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ declare global temporary table env_inst_info_end like session.env_inst_info_start on commit preserve rows not logged;
/* IBM_DB2MON */ drop table session.mon_get_bufferpool_start;
/* IBM_DB2MON */ drop table session.mon_get_bufferpool_end;
/* IBM_DB2MON */ declare global temporary table mon_get_bufferpool_start as ( select current timestamp ts,member, bp_name, bp_cur_buffsz, automatic, pool_read_time, pool_data_l_reads, pool_data_p_reads, pool_async_read_time, pool_async_data_reads, pool_async_index_reads, pool_async_xda_reads, pool_data_writes, pool_async_data_writes, pool_data_lbp_pages_found, pool_async_data_lbp_pages_found, pool_temp_data_l_reads, pool_temp_data_p_reads, pool_index_lbp_pages_found, pool_async_index_lbp_pages_found, pool_temp_index_l_reads, pool_temp_index_p_reads, pool_write_time, pool_async_write_time, pool_index_l_reads, pool_index_p_reads, pool_index_writes, pool_async_index_writes, pool_xda_l_reads, pool_temp_xda_l_reads, pool_xda_p_reads, pool_temp_xda_p_reads, pool_xda_writes, pool_async_xda_writes from table (mon_get_bufferpool( null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ declare global temporary table mon_get_bufferpool_end like session.mon_get_bufferpool_start on commit preserve rows not logged;
/* IBM_DB2MON */ drop table session.mon_get_bufferpool_diff;
/* IBM_DB2MON */ declare global temporary table mon_get_bufferpool_diff as ( select cast(null as integer) ts_delta, current timestamp ts,member, bp_name, bp_cur_buffsz, automatic, pool_read_time, pool_data_l_reads, pool_data_p_reads, pool_async_read_time, pool_async_data_reads, pool_async_index_reads, pool_async_xda_reads, pool_data_writes, pool_async_data_writes, pool_data_lbp_pages_found, pool_async_data_lbp_pages_found, pool_temp_data_l_reads, pool_temp_data_p_reads, pool_index_lbp_pages_found, pool_async_index_lbp_pages_found, pool_temp_index_l_reads, pool_temp_index_p_reads, pool_write_time, pool_async_write_time, pool_index_l_reads, pool_index_p_reads, pool_index_writes, pool_async_index_writes, pool_xda_l_reads, pool_temp_xda_l_reads, pool_xda_p_reads, pool_temp_xda_p_reads, pool_xda_writes, pool_async_xda_writes from table (mon_get_bufferpool( null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ create index session.idx_mon_get_bufferpool_start on session.mon_get_bufferpool_start (member, bp_name);
/* IBM_DB2MON */ create index session.idx_mon_get_bufferpool_end on session.mon_get_bufferpool_end (member, bp_name);
/* IBM_DB2MON */ drop table session.mon_get_connection_start;
/* IBM_DB2MON */ drop table session.mon_get_connection_end;
/* IBM_DB2MON */ declare global temporary table mon_get_connection_start as ( select current timestamp ts,member, application_name, application_handle, client_applname, client_idle_wait_time, total_rqst_time, rqsts_completed_total, total_wait_time, lock_wait_time, log_disk_wait_time, fcm_recv_wait_time, fcm_send_wait_time, pool_write_time, pool_read_time, direct_write_time, direct_read_time, total_section_sort_time, total_commit_time, total_runstats_time, total_reorg_time, total_load_time, total_app_commits, total_app_rollbacks, deadlocks, rows_modified, rows_read, rows_returned, total_sorts, total_reorgs, total_loads, total_runstats, pool_data_l_reads, pool_data_p_reads, pool_index_l_reads, pool_index_p_reads, ida_send_wait_time, ida_recv_wait_time from table (mon_get_connection( null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ declare global temporary table mon_get_connection_end like session.mon_get_connection_start on commit preserve rows not logged;
/* IBM_DB2MON */ drop table session.mon_get_connection_diff;
/* IBM_DB2MON */ declare global temporary table mon_get_connection_diff as ( select cast(null as integer) ts_delta, current timestamp ts,member, application_name, application_handle, client_applname, client_idle_wait_time, total_rqst_time, rqsts_completed_total, total_wait_time, lock_wait_time, log_disk_wait_time, fcm_recv_wait_time, fcm_send_wait_time, pool_write_time, pool_read_time, direct_write_time, direct_read_time, total_section_sort_time, total_commit_time, total_runstats_time, total_reorg_time, total_load_time, total_app_commits, total_app_rollbacks, deadlocks, rows_modified, rows_read, rows_returned, total_sorts, total_reorgs, total_loads, total_runstats, pool_data_l_reads, pool_data_p_reads, pool_index_l_reads, pool_index_p_reads, ida_send_wait_time, ida_recv_wait_time from table (mon_get_connection( null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ create index session.idx_mon_get_connection_start on session.mon_get_connection_start (member, application_name, application_handle, client_applname);
/* IBM_DB2MON */ create index session.idx_mon_get_connection_end on session.mon_get_connection_end (member, application_name, application_handle, client_applname);
/* IBM_DB2MON */ drop table session.mon_get_index_start;
/* IBM_DB2MON */ drop table session.mon_get_index_end;
/* IBM_DB2MON */ declare global temporary table mon_get_index_start as ( select current timestamp ts,member, tabschema, tabname, iid, data_partition_id, nleaf, nlevels, index_scans, index_only_scans, key_updates, include_col_updates, pseudo_deletes, del_keys_cleaned, root_node_splits, int_node_splits, boundary_leaf_node_splits, nonboundary_leaf_node_splits, page_allocations, pseudo_empty_pages, empty_pages_reused, empty_pages_deleted, pages_merged from table (mon_get_index( null, null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ declare global temporary table mon_get_index_end like session.mon_get_index_start on commit preserve rows not logged;
/* IBM_DB2MON */ drop table session.mon_get_index_diff;
/* IBM_DB2MON */ declare global temporary table mon_get_index_diff as ( select cast(null as integer) ts_delta, current timestamp ts,member, tabschema, tabname, iid, data_partition_id, nleaf, nlevels, index_scans, index_only_scans, key_updates, include_col_updates, pseudo_deletes, del_keys_cleaned, root_node_splits, int_node_splits, boundary_leaf_node_splits, nonboundary_leaf_node_splits, page_allocations, pseudo_empty_pages, empty_pages_reused, empty_pages_deleted, pages_merged from table (mon_get_index( null, null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ create index session.idx_mon_get_index_start on session.mon_get_index_start (member, tabschema, tabname, iid, data_partition_id);
/* IBM_DB2MON */ create index session.idx_mon_get_index_end on session.mon_get_index_end (member, tabschema, tabname, iid, data_partition_id);
/* IBM_DB2MON */ drop table session.mon_get_memory_pool_start;
/* IBM_DB2MON */ drop table session.mon_get_memory_pool_end;
/* IBM_DB2MON */ declare global temporary table mon_get_memory_pool_start as ( select current timestamp ts,member, memory_pool_type, db_name, memory_pool_used, memory_pool_used_hwm from table (mon_get_memory_pool( 'database', null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ declare global temporary table mon_get_memory_pool_end like session.mon_get_memory_pool_start on commit preserve rows not logged;
/* IBM_DB2MON */ drop table session.mon_get_memory_pool_diff;
/* IBM_DB2MON */ declare global temporary table mon_get_memory_pool_diff as ( select cast(null as integer) ts_delta, current timestamp ts,member, memory_pool_type, db_name, memory_pool_used, memory_pool_used_hwm from table (mon_get_memory_pool( 'database', null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ create index session.idx_mon_get_memory_pool_start on session.mon_get_memory_pool_start (member);
/* IBM_DB2MON */ create index session.idx_mon_get_memory_pool_end on session.mon_get_memory_pool_end (member);
/* IBM_DB2MON */ drop table session.mon_get_memory_set_start;
/* IBM_DB2MON */ drop table session.mon_get_memory_set_end;
/* IBM_DB2MON */ declare global temporary table mon_get_memory_set_start as ( select current timestamp ts,member, memory_set_type, db_name, memory_set_used, memory_set_used_hwm from table (mon_get_memory_set( null, null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ declare global temporary table mon_get_memory_set_end like session.mon_get_memory_set_start on commit preserve rows not logged;
/* IBM_DB2MON */ drop table session.mon_get_memory_set_diff;
/* IBM_DB2MON */ declare global temporary table mon_get_memory_set_diff as ( select cast(null as integer) ts_delta, current timestamp ts,member, memory_set_type, db_name, memory_set_used, memory_set_used_hwm from table (mon_get_memory_set( null, null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ create index session.idx_mon_get_memory_set_start on session.mon_get_memory_set_start (member);
/* IBM_DB2MON */ create index session.idx_mon_get_memory_set_end on session.mon_get_memory_set_end (member);
/* IBM_DB2MON */ drop table session.mon_get_pkg_cache_stmt_start;
/* IBM_DB2MON */ drop table session.mon_get_pkg_cache_stmt_end;
/* IBM_DB2MON */ declare global temporary table mon_get_pkg_cache_stmt_start as ( select current timestamp ts,member, executable_id, package_name, stmt_text, effective_isolation, num_exec_with_metrics, coord_stmt_exec_time, total_act_time, total_cpu_time, total_act_wait_time, lock_wait_time, log_disk_wait_time, log_buffer_wait_time, pool_write_time, pool_read_time, direct_write_time, direct_read_time, rows_modified, rows_read, rows_returned, total_sorts, sort_overflows, total_section_time, total_section_sort_time, pool_data_l_reads, pool_index_l_reads, pool_data_p_reads, pool_index_p_reads, pool_data_writes, pool_index_writes, pool_temp_data_p_reads, pool_temp_index_p_reads, direct_read_reqs, direct_write_reqs, ida_send_wait_time, ida_recv_wait_time from table (mon_get_pkg_cache_stmt( null, null, null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ declare global temporary table mon_get_pkg_cache_stmt_end like session.mon_get_pkg_cache_stmt_start on commit preserve rows not logged;
/* IBM_DB2MON */ drop table session.mon_get_pkg_cache_stmt_diff;
/* IBM_DB2MON */ declare global temporary table mon_get_pkg_cache_stmt_diff as ( select cast(null as integer) ts_delta, current timestamp ts,member, executable_id, package_name, stmt_text, effective_isolation, num_exec_with_metrics, coord_stmt_exec_time, total_act_time, total_cpu_time, total_act_wait_time, lock_wait_time, log_disk_wait_time, log_buffer_wait_time, pool_write_time, pool_read_time, direct_write_time, direct_read_time, rows_modified, rows_read, rows_returned, total_sorts, sort_overflows, total_section_time, total_section_sort_time, pool_data_l_reads, pool_index_l_reads, pool_data_p_reads, pool_index_p_reads, pool_data_writes, pool_index_writes, pool_temp_data_p_reads, pool_temp_index_p_reads, direct_read_reqs, direct_write_reqs, ida_send_wait_time, ida_recv_wait_time from table (mon_get_pkg_cache_stmt( null, null, null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ create index session.idx_mon_get_pkg_cache_stmt_start on session.mon_get_pkg_cache_stmt_start (member, executable_id);
/* IBM_DB2MON */ create index session.idx_mon_get_pkg_cache_stmt_end on session.mon_get_pkg_cache_stmt_end (member, executable_id);
/* IBM_DB2MON */ drop table session.mon_get_table_start;
/* IBM_DB2MON */ drop table session.mon_get_table_end;
/* IBM_DB2MON */ declare global temporary table mon_get_table_start as ( select current timestamp ts,member, tabname, tabschema, data_partition_id, tbsp_id, tab_file_id, rows_read, rows_inserted, rows_updated, rows_deleted, overflow_accesses, overflow_creates, page_reorgs from table (mon_get_table( null, null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ declare global temporary table mon_get_table_end like session.mon_get_table_start on commit preserve rows not logged;
/* IBM_DB2MON */ drop table session.mon_get_table_diff;
/* IBM_DB2MON */ declare global temporary table mon_get_table_diff as ( select cast(null as integer) ts_delta, current timestamp ts,member, tabname, tabschema, data_partition_id, tbsp_id, tab_file_id, rows_read, rows_inserted, rows_updated, rows_deleted, overflow_accesses, overflow_creates, page_reorgs from table (mon_get_table( null, null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ create index session.idx_mon_get_table_start on session.mon_get_table_start (member, tabname, tabschema, data_partition_id, tbsp_id, tab_file_id);
/* IBM_DB2MON */ create index session.idx_mon_get_table_end on session.mon_get_table_end (member, tabname, tabschema, data_partition_id, tbsp_id, tab_file_id);
/* IBM_DB2MON */ drop table session.mon_get_tablespace_start;
/* IBM_DB2MON */ drop table session.mon_get_tablespace_end;
/* IBM_DB2MON */ declare global temporary table mon_get_tablespace_start as ( select current timestamp ts,member, tbsp_name, tbsp_page_size, tbsp_id, tbsp_extent_size, tbsp_prefetch_size, fs_caching, pool_read_time, pool_async_read_time, pool_write_time, pool_async_write_time, pool_data_writes, pool_async_data_writes, pool_index_writes, pool_async_index_writes, pool_data_l_reads, pool_temp_data_l_reads, pool_async_data_reads, pool_data_p_reads, pool_temp_data_p_reads, pool_async_index_reads, pool_index_l_reads, pool_temp_index_l_reads, pool_index_p_reads, pool_temp_index_p_reads, pool_xda_l_reads, pool_temp_xda_l_reads, pool_async_xda_reads, pool_xda_p_reads, pool_temp_xda_p_reads, pool_xda_writes, pool_async_xda_writes, unread_prefetch_pages, vectored_ios, pages_from_vectored_ios, block_ios, pages_from_block_ios, pool_data_lbp_pages_found, pool_index_lbp_pages_found, pool_async_data_lbp_pages_found, pool_async_index_lbp_pages_found, direct_read_reqs, direct_write_reqs, direct_read_time, direct_write_time, tbsp_used_pages, tbsp_page_top from table (mon_get_tablespace( null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ declare global temporary table mon_get_tablespace_end like session.mon_get_tablespace_start on commit preserve rows not logged;
/* IBM_DB2MON */ drop table session.mon_get_tablespace_diff;
/* IBM_DB2MON */ declare global temporary table mon_get_tablespace_diff as ( select cast(null as integer) ts_delta, current timestamp ts,member, tbsp_name, tbsp_page_size, tbsp_id, tbsp_extent_size, tbsp_prefetch_size, fs_caching, pool_read_time, pool_async_read_time, pool_write_time, pool_async_write_time, pool_data_writes, pool_async_data_writes, pool_index_writes, pool_async_index_writes, pool_data_l_reads, pool_temp_data_l_reads, pool_async_data_reads, pool_data_p_reads, pool_temp_data_p_reads, pool_async_index_reads, pool_index_l_reads, pool_temp_index_l_reads, pool_index_p_reads, pool_temp_index_p_reads, pool_xda_l_reads, pool_temp_xda_l_reads, pool_async_xda_reads, pool_xda_p_reads, pool_temp_xda_p_reads, pool_xda_writes, pool_async_xda_writes, unread_prefetch_pages, vectored_ios, pages_from_vectored_ios, block_ios, pages_from_block_ios, pool_data_lbp_pages_found, pool_index_lbp_pages_found, pool_async_data_lbp_pages_found, pool_async_index_lbp_pages_found, direct_read_reqs, direct_write_reqs, direct_read_time, direct_write_time, tbsp_used_pages, tbsp_page_top from table (mon_get_tablespace( null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ create index session.idx_mon_get_tablespace_start on session.mon_get_tablespace_start (member, tbsp_name);
/* IBM_DB2MON */ create index session.idx_mon_get_tablespace_end on session.mon_get_tablespace_end (member, tbsp_name);
/* IBM_DB2MON */ drop table session.mon_get_workload_start;
/* IBM_DB2MON */ drop table session.mon_get_workload_end;
/* IBM_DB2MON */ declare global temporary table mon_get_workload_start as ( select current timestamp ts,member, workload_name, act_completed_total, total_act_time, total_rqst_time, total_wait_time, lock_wait_time, log_disk_wait_time, pool_write_time, pool_read_time, direct_write_time, direct_read_time, tcpip_recv_wait_time, tcpip_send_wait_time, fcm_recv_wait_time, fcm_send_wait_time, total_cpu_time, total_compile_time, total_compile_proc_time, total_routine_time, total_section_sort_time, total_section_sort_proc_time, total_section_time, total_section_proc_time, total_commit_time, total_rollback_time, total_runstats_time, total_reorg_time, total_load_time, total_app_commits, total_app_rollbacks, deadlocks, lock_timeouts, lock_escals, client_idle_wait_time, rows_modified, rows_read, rows_returned, pkg_cache_inserts, total_sorts, sort_overflows, post_threshold_sorts, post_shrthreshold_sorts, total_reorgs, total_loads, total_runstats, pool_data_l_reads, pool_data_p_reads, pool_temp_data_p_reads, pool_index_l_reads, pool_index_p_reads, pool_temp_index_p_reads, pool_xda_p_reads, pool_temp_xda_p_reads, ida_send_wait_time, ida_recv_wait_time from table (mon_get_workload( null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ declare global temporary table mon_get_workload_end like session.mon_get_workload_start on commit preserve rows not logged;
/* IBM_DB2MON */ drop table session.mon_get_workload_diff;
/* IBM_DB2MON */ declare global temporary table mon_get_workload_diff as ( select cast(null as integer) ts_delta, current timestamp ts,member, workload_name, act_completed_total, total_act_time, total_rqst_time, total_wait_time, lock_wait_time, log_disk_wait_time, pool_write_time, pool_read_time, direct_write_time, direct_read_time, tcpip_recv_wait_time, tcpip_send_wait_time, fcm_recv_wait_time, fcm_send_wait_time, total_cpu_time, total_compile_time, total_compile_proc_time, total_routine_time, total_section_sort_time, total_section_sort_proc_time, total_section_time, total_section_proc_time, total_commit_time, total_rollback_time, total_runstats_time, total_reorg_time, total_load_time, total_app_commits, total_app_rollbacks, deadlocks, lock_timeouts, lock_escals, client_idle_wait_time, rows_modified, rows_read, rows_returned, pkg_cache_inserts, total_sorts, sort_overflows, post_threshold_sorts, post_shrthreshold_sorts, total_reorgs, total_loads, total_runstats, pool_data_l_reads, pool_data_p_reads, pool_temp_data_p_reads, pool_index_l_reads, pool_index_p_reads, pool_temp_index_p_reads, pool_xda_p_reads, pool_temp_xda_p_reads, ida_send_wait_time, ida_recv_wait_time from table (mon_get_workload( null, -2) ) ) with no data on commit preserve rows not logged;
/* IBM_DB2MON */ create index session.idx_mon_get_workload_start on session.mon_get_workload_start (member, workload_name);
/* IBM_DB2MON */ create index session.idx_mon_get_workload_end on session.mon_get_workload_end (member, workload_name);

/* IBM_DB2MON */ drop table session.mon_current_sql_plus_start;
/* IBM_DB2MON */ drop table session.mon_current_sql_plus_end;

/* IBM_DB2MON */ declare global temporary table session.mon_current_sql_plus_start as
( select /* IBM_DB2MON */ current timestamp ts, mcs.coord_member,mcs.application_handle,mcs.elapsed_time_sec,mcs.total_cpu_time,mcs.rows_read,mcs.direct_reads,mcs.direct_writes,mcs.stmt_text
from 
  sysibmadm.mon_current_sql mcs 
 where 
  mcs.stmt_text not like '%/* IBM_DB2MON */%'
) with no data on commit preserve rows not logged;
;

/* IBM_DB2MON */ declare global temporary table mon_current_sql_plus_end like session.mon_current_sql_plus_start on commit preserve rows not logged;
;


/* IBM_DB2MON */ drop table session.mon_get_locks_start;
/* IBM_DB2MON */ drop table session.mon_get_locks_end;

/* IBM_DB2MON */ declare global temporary table session.mon_get_locks_start as
( 
   select
   /* IBM_DB2MON */
   distinct
   member,
   application_handle,
   lock_mode,
   lock_status,
   lock_object_type,
   lock_name,
   tbsp_id,
   tab_file_id
from
   table ( mon_get_locks(null,-2) )
) with no data on commit preserve rows not logged;
;

/* IBM_DB2MON */ declare global temporary table session.mon_get_locks_end like session.mon_get_locks_start on commit preserve rows not logged;
;

/* IBM_DB2MON */ insert into session.dbmcfg_start select current timestamp,name, value, value_flags from sysibmadm.dbmcfg;
/* IBM_DB2MON */ insert into session.env_get_system_resources_start select current timestamp,member, os_name, host_name, os_version, os_release, cpu_total, cpu_online, cpu_configured, cpu_speed, cpu_hmt_degree, memory_total, memory_free, cpu_load_short, cpu_load_medium, cpu_load_long, cpu_usage_total, swap_pages_in, swap_pages_out from table (sysproc.env_get_system_resources( ) );
/* IBM_DB2MON */ insert into session.env_inst_info_start select current timestamp,inst_name, num_dbpartitions, service_level, bld_level, ptf from sysibmadm.env_inst_info;
/* IBM_DB2MON */ insert into session.mon_get_bufferpool_start select current timestamp,member, bp_name, bp_cur_buffsz, automatic, pool_read_time, pool_data_l_reads, pool_data_p_reads, pool_async_read_time, pool_async_data_reads, pool_async_index_reads, pool_async_xda_reads, pool_data_writes, pool_async_data_writes, pool_data_lbp_pages_found, pool_async_data_lbp_pages_found, pool_temp_data_l_reads, pool_temp_data_p_reads, pool_index_lbp_pages_found, pool_async_index_lbp_pages_found, pool_temp_index_l_reads, pool_temp_index_p_reads, pool_write_time, pool_async_write_time, pool_index_l_reads, pool_index_p_reads, pool_index_writes, pool_async_index_writes, pool_xda_l_reads, pool_temp_xda_l_reads, pool_xda_p_reads, pool_temp_xda_p_reads, pool_xda_writes, pool_async_xda_writes from table (mon_get_bufferpool( null, -2) );
/* IBM_DB2MON */ insert into session.mon_get_connection_start select current timestamp,member, application_name, application_handle, client_applname, client_idle_wait_time, total_rqst_time, rqsts_completed_total, total_wait_time, lock_wait_time, log_disk_wait_time, fcm_recv_wait_time, fcm_send_wait_time, pool_write_time, pool_read_time, direct_write_time, direct_read_time, total_section_sort_time, total_commit_time, total_runstats_time, total_reorg_time, total_load_time, total_app_commits, total_app_rollbacks, deadlocks, rows_modified, rows_read, rows_returned, total_sorts, total_reorgs, total_loads, total_runstats, pool_data_l_reads, pool_data_p_reads, pool_index_l_reads, pool_index_p_reads, ida_send_wait_time, ida_recv_wait_time from table (mon_get_connection( null, -2) );
/* IBM_DB2MON */ insert into session.mon_get_index_start select current timestamp,member, tabschema, tabname, iid, data_partition_id, nleaf, nlevels, index_scans, index_only_scans, key_updates, include_col_updates, pseudo_deletes, del_keys_cleaned, root_node_splits, int_node_splits, boundary_leaf_node_splits, nonboundary_leaf_node_splits, page_allocations, pseudo_empty_pages, empty_pages_reused, empty_pages_deleted, pages_merged from table (mon_get_index( null, null, -2) );
/* IBM_DB2MON */ insert into session.mon_get_memory_pool_start select current timestamp,member, memory_pool_type, db_name, memory_pool_used, memory_pool_used_hwm from table (mon_get_memory_pool( 'database', null, -2) );
/* IBM_DB2MON */ insert into session.mon_get_memory_set_start select current timestamp,member, memory_set_type, db_name, memory_set_used, memory_set_used_hwm from table (mon_get_memory_set( null, null, -2) );
/* IBM_DB2MON */ insert into session.mon_get_pkg_cache_stmt_start select current timestamp,member, executable_id, package_name, stmt_text, effective_isolation, num_exec_with_metrics, coord_stmt_exec_time, total_act_time, total_cpu_time, total_act_wait_time, lock_wait_time, log_disk_wait_time, log_buffer_wait_time, pool_write_time, pool_read_time, direct_write_time, direct_read_time, rows_modified, rows_read, rows_returned, total_sorts, sort_overflows, total_section_time, total_section_sort_time, pool_data_l_reads, pool_index_l_reads, pool_data_p_reads, pool_index_p_reads, pool_data_writes, pool_index_writes, pool_temp_data_p_reads, pool_temp_index_p_reads, direct_read_reqs, direct_write_reqs, ida_send_wait_time, ida_recv_wait_time from table (mon_get_pkg_cache_stmt( null, null, null, -2) ) where stmt_text not like 'CALL dbms_alert.sleep%' and stmt_text not like '%/* IBM_DB2MON */%';
/* IBM_DB2MON */ insert into session.mon_get_table_start select current timestamp,member, tabname, tabschema, data_partition_id, tbsp_id, tab_file_id, rows_read, rows_inserted, rows_updated, rows_deleted, overflow_accesses, overflow_creates, page_reorgs from table (mon_get_table( null, null, -2) );
/* IBM_DB2MON */ insert into session.mon_get_tablespace_start select current timestamp,member, tbsp_name, tbsp_page_size, tbsp_id, tbsp_extent_size, tbsp_prefetch_size, fs_caching, pool_read_time, pool_async_read_time, pool_write_time, pool_async_write_time, pool_data_writes, pool_async_data_writes, pool_index_writes, pool_async_index_writes, pool_data_l_reads, pool_temp_data_l_reads, pool_async_data_reads, pool_data_p_reads, pool_temp_data_p_reads, pool_async_index_reads, pool_index_l_reads, pool_temp_index_l_reads, pool_index_p_reads, pool_temp_index_p_reads, pool_xda_l_reads, pool_temp_xda_l_reads, pool_async_xda_reads, pool_xda_p_reads, pool_temp_xda_p_reads, pool_xda_writes, pool_async_xda_writes, unread_prefetch_pages, vectored_ios, pages_from_vectored_ios, block_ios, pages_from_block_ios, pool_data_lbp_pages_found, pool_index_lbp_pages_found, pool_async_data_lbp_pages_found, pool_async_index_lbp_pages_found, direct_read_reqs, direct_write_reqs, direct_read_time, direct_write_time, tbsp_used_pages, tbsp_page_top from table (mon_get_tablespace( null, -2) ) where tbsp_used_pages > 1000;
/* IBM_DB2MON */ insert into session.mon_get_workload_start select current timestamp,member, workload_name, act_completed_total, total_act_time, total_rqst_time, total_wait_time, lock_wait_time, log_disk_wait_time, pool_write_time, pool_read_time, direct_write_time, direct_read_time, tcpip_recv_wait_time, tcpip_send_wait_time, fcm_recv_wait_time, fcm_send_wait_time, total_cpu_time, total_compile_time, total_compile_proc_time, total_routine_time, total_section_sort_time, total_section_sort_proc_time, total_section_time, total_section_proc_time, total_commit_time, total_rollback_time, total_runstats_time, total_reorg_time, total_load_time, total_app_commits, total_app_rollbacks, deadlocks, lock_timeouts, lock_escals, client_idle_wait_time, rows_modified, rows_read, rows_returned, pkg_cache_inserts, total_sorts, sort_overflows, post_threshold_sorts, post_shrthreshold_sorts, total_reorgs, total_loads, total_runstats, pool_data_l_reads, pool_data_p_reads, pool_temp_data_p_reads, pool_index_l_reads, pool_index_p_reads, pool_temp_index_p_reads, pool_xda_p_reads, pool_temp_xda_p_reads, ida_send_wait_time, ida_recv_wait_time from table (mon_get_workload( null, -2) );

  /* IBM_DB2MON */ insert into session.mon_current_sql_plus_start
    select /* IBM_DB2MON */ current timestamp ts, mcs.coord_member,mcs.application_handle,mcs.elapsed_time_sec,mcs.total_cpu_time,mcs.rows_read,mcs.direct_reads,mcs.direct_writes,mcs.stmt_text
from 
  sysibmadm.mon_current_sql mcs 
 where 
  mcs.stmt_text not like '%/* IBM_DB2MON */%'
  with UR;

  /* IBM_DB2MON */ insert into session.mon_get_locks_start
    
   select
   /* IBM_DB2MON */
   distinct
   member,
   application_handle,
   lock_mode,
   lock_status,
   lock_object_type,
   lock_name,
   tbsp_id,
   tab_file_id
from
   table ( mon_get_locks(null,-2) )
  with UR;

/* IBM_DB2MON */ commit work;
/* IBM_DB2MON */ select current timestamp as monitor_start_time from sysibm.sysdummy1;
/* IBM_DB2MON */ call dbms_alert.sleep(30);
/* IBM_DB2MON */ select current timestamp as monitor_end_time from sysibm.sysdummy1;
/* IBM_DB2MON */ insert into session.dbmcfg_end select current timestamp,name, value, value_flags from sysibmadm.dbmcfg;
/* IBM_DB2MON */ insert into session.env_get_system_resources_end select current timestamp,member, os_name, host_name, os_version, os_release, cpu_total, cpu_online, cpu_configured, cpu_speed, cpu_hmt_degree, memory_total, memory_free, cpu_load_short, cpu_load_medium, cpu_load_long, cpu_usage_total, swap_pages_in, swap_pages_out from table (sysproc.env_get_system_resources( ) );
/* IBM_DB2MON */ insert into session.env_inst_info_end select current timestamp,inst_name, num_dbpartitions, service_level, bld_level, ptf from sysibmadm.env_inst_info;
/* IBM_DB2MON */ insert into session.mon_get_bufferpool_end select current timestamp,member, bp_name, bp_cur_buffsz, automatic, pool_read_time, pool_data_l_reads, pool_data_p_reads, pool_async_read_time, pool_async_data_reads, pool_async_index_reads, pool_async_xda_reads, pool_data_writes, pool_async_data_writes, pool_data_lbp_pages_found, pool_async_data_lbp_pages_found, pool_temp_data_l_reads, pool_temp_data_p_reads, pool_index_lbp_pages_found, pool_async_index_lbp_pages_found, pool_temp_index_l_reads, pool_temp_index_p_reads, pool_write_time, pool_async_write_time, pool_index_l_reads, pool_index_p_reads, pool_index_writes, pool_async_index_writes, pool_xda_l_reads, pool_temp_xda_l_reads, pool_xda_p_reads, pool_temp_xda_p_reads, pool_xda_writes, pool_async_xda_writes from table (mon_get_bufferpool( null, -2) );
/* IBM_DB2MON */ insert into session.mon_get_connection_end select current timestamp,member, application_name, application_handle, client_applname, client_idle_wait_time, total_rqst_time, rqsts_completed_total, total_wait_time, lock_wait_time, log_disk_wait_time, fcm_recv_wait_time, fcm_send_wait_time, pool_write_time, pool_read_time, direct_write_time, direct_read_time, total_section_sort_time, total_commit_time, total_runstats_time, total_reorg_time, total_load_time, total_app_commits, total_app_rollbacks, deadlocks, rows_modified, rows_read, rows_returned, total_sorts, total_reorgs, total_loads, total_runstats, pool_data_l_reads, pool_data_p_reads, pool_index_l_reads, pool_index_p_reads, ida_send_wait_time, ida_recv_wait_time from table (mon_get_connection( null, -2) );
/* IBM_DB2MON */ insert into session.mon_get_index_end select current timestamp,member, tabschema, tabname, iid, data_partition_id, nleaf, nlevels, index_scans, index_only_scans, key_updates, include_col_updates, pseudo_deletes, del_keys_cleaned, root_node_splits, int_node_splits, boundary_leaf_node_splits, nonboundary_leaf_node_splits, page_allocations, pseudo_empty_pages, empty_pages_reused, empty_pages_deleted, pages_merged from table (mon_get_index( null, null, -2) );
/* IBM_DB2MON */ insert into session.mon_get_memory_pool_end select current timestamp,member, memory_pool_type, db_name, memory_pool_used, memory_pool_used_hwm from table (mon_get_memory_pool( 'database', null, -2) );
/* IBM_DB2MON */ insert into session.mon_get_memory_set_end select current timestamp,member, memory_set_type, db_name, memory_set_used, memory_set_used_hwm from table (mon_get_memory_set( null, null, -2) );
/* IBM_DB2MON */ insert into session.mon_get_pkg_cache_stmt_end select current timestamp,member, executable_id, package_name, stmt_text, effective_isolation, num_exec_with_metrics, coord_stmt_exec_time, total_act_time, total_cpu_time, total_act_wait_time, lock_wait_time, log_disk_wait_time, log_buffer_wait_time, pool_write_time, pool_read_time, direct_write_time, direct_read_time, rows_modified, rows_read, rows_returned, total_sorts, sort_overflows, total_section_time, total_section_sort_time, pool_data_l_reads, pool_index_l_reads, pool_data_p_reads, pool_index_p_reads, pool_data_writes, pool_index_writes, pool_temp_data_p_reads, pool_temp_index_p_reads, direct_read_reqs, direct_write_reqs, ida_send_wait_time, ida_recv_wait_time from table (mon_get_pkg_cache_stmt( null, null, null, -2) ) where stmt_text not like 'CALL dbms_alert.sleep%' and stmt_text not like '%/* IBM_DB2MON */%';
/* IBM_DB2MON */ insert into session.mon_get_table_end select current timestamp,member, tabname, tabschema, data_partition_id, tbsp_id, tab_file_id, rows_read, rows_inserted, rows_updated, rows_deleted, overflow_accesses, overflow_creates, page_reorgs from table (mon_get_table( null, null, -2) );
/* IBM_DB2MON */ insert into session.mon_get_tablespace_end select current timestamp,member, tbsp_name, tbsp_page_size, tbsp_id, tbsp_extent_size, tbsp_prefetch_size, fs_caching, pool_read_time, pool_async_read_time, pool_write_time, pool_async_write_time, pool_data_writes, pool_async_data_writes, pool_index_writes, pool_async_index_writes, pool_data_l_reads, pool_temp_data_l_reads, pool_async_data_reads, pool_data_p_reads, pool_temp_data_p_reads, pool_async_index_reads, pool_index_l_reads, pool_temp_index_l_reads, pool_index_p_reads, pool_temp_index_p_reads, pool_xda_l_reads, pool_temp_xda_l_reads, pool_async_xda_reads, pool_xda_p_reads, pool_temp_xda_p_reads, pool_xda_writes, pool_async_xda_writes, unread_prefetch_pages, vectored_ios, pages_from_vectored_ios, block_ios, pages_from_block_ios, pool_data_lbp_pages_found, pool_index_lbp_pages_found, pool_async_data_lbp_pages_found, pool_async_index_lbp_pages_found, direct_read_reqs, direct_write_reqs, direct_read_time, direct_write_time, tbsp_used_pages, tbsp_page_top from table (mon_get_tablespace( null, -2) ) where tbsp_used_pages > 1000;
/* IBM_DB2MON */ insert into session.mon_get_workload_end select current timestamp,member, workload_name, act_completed_total, total_act_time, total_rqst_time, total_wait_time, lock_wait_time, log_disk_wait_time, pool_write_time, pool_read_time, direct_write_time, direct_read_time, tcpip_recv_wait_time, tcpip_send_wait_time, fcm_recv_wait_time, fcm_send_wait_time, total_cpu_time, total_compile_time, total_compile_proc_time, total_routine_time, total_section_sort_time, total_section_sort_proc_time, total_section_time, total_section_proc_time, total_commit_time, total_rollback_time, total_runstats_time, total_reorg_time, total_load_time, total_app_commits, total_app_rollbacks, deadlocks, lock_timeouts, lock_escals, client_idle_wait_time, rows_modified, rows_read, rows_returned, pkg_cache_inserts, total_sorts, sort_overflows, post_threshold_sorts, post_shrthreshold_sorts, total_reorgs, total_loads, total_runstats, pool_data_l_reads, pool_data_p_reads, pool_temp_data_p_reads, pool_index_l_reads, pool_index_p_reads, pool_temp_index_p_reads, pool_xda_p_reads, pool_temp_xda_p_reads, ida_send_wait_time, ida_recv_wait_time from table (mon_get_workload( null, -2) );

  /* IBM_DB2MON */ insert into session.mon_current_sql_plus_end
    select /* IBM_DB2MON */ current timestamp ts, mcs.coord_member,mcs.application_handle,mcs.elapsed_time_sec,mcs.total_cpu_time,mcs.rows_read,mcs.direct_reads,mcs.direct_writes,mcs.stmt_text
from 
  sysibmadm.mon_current_sql mcs 
 where 
  mcs.stmt_text not like '%/* IBM_DB2MON */%'
  with UR;

  /* IBM_DB2MON */ insert into session.mon_get_locks_end
    
   select
   /* IBM_DB2MON */
   distinct
   member,
   application_handle,
   lock_mode,
   lock_status,
   lock_object_type,
   lock_name,
   tbsp_id,
   tab_file_id
from
   table ( mon_get_locks(null,-2) )
  with UR;

/* IBM_DB2MON */ insert into session.env_get_system_resources_diff select (((JULIAN_DAY(e.ts)-JULIAN_DAY(s.ts))*24 + (HOUR(e.ts)-HOUR(s.ts)))*60 + (MINUTE(e.ts)-MINUTE(s.ts)))*60 + (SECOND(e.ts)-SECOND(s.ts)),e.ts,s.member, s.os_name, s.host_name, s.os_version, s.os_release, s.cpu_total, s.cpu_online, s.cpu_configured, s.cpu_speed, s.cpu_hmt_degree, s.memory_total, s.memory_free, s.cpu_load_short, s.cpu_load_medium, s.cpu_load_long, s.cpu_usage_total, e.swap_pages_in - s.swap_pages_in as swap_pages_in, e.swap_pages_out - s.swap_pages_out as swap_pages_out from session.env_get_system_resources_start s, session.env_get_system_resources_end e where (s.member = e.member or (s.member is NULL and e.member is NULL)) with UR;
/* IBM_DB2MON */ insert into session.env_get_system_resources_diff select null, e.ts,e.member, e.os_name, e.host_name, e.os_version, e.os_release, e.cpu_total, e.cpu_online, e.cpu_configured, e.cpu_speed, e.cpu_hmt_degree, e.memory_total, e.memory_free, e.cpu_load_short, e.cpu_load_medium, e.cpu_load_long, e.cpu_usage_total, e.swap_pages_in, e.swap_pages_out from session.env_get_system_resources_end e where not exists ( select null from session.env_get_system_resources_start s where (s.member = e.member or (s.member is NULL and e.member is NULL)) ) with UR;
/* IBM_DB2MON */ update session.env_get_system_resources_diff set ts_delta = (select max(ts_delta) from session.env_get_system_resources_diff) where ts_delta is null;
/* IBM_DB2MON */ insert into session.mon_get_bufferpool_diff select (((JULIAN_DAY(e.ts)-JULIAN_DAY(s.ts))*24 + (HOUR(e.ts)-HOUR(s.ts)))*60 + (MINUTE(e.ts)-MINUTE(s.ts)))*60 + (SECOND(e.ts)-SECOND(s.ts)),e.ts,s.member, s.bp_name, s.bp_cur_buffsz, s.automatic, e.pool_read_time - s.pool_read_time as pool_read_time, e.pool_data_l_reads - s.pool_data_l_reads as pool_data_l_reads, e.pool_data_p_reads - s.pool_data_p_reads as pool_data_p_reads, e.pool_async_read_time - s.pool_async_read_time as pool_async_read_time, e.pool_async_data_reads - s.pool_async_data_reads as pool_async_data_reads, e.pool_async_index_reads - s.pool_async_index_reads as pool_async_index_reads, e.pool_async_xda_reads - s.pool_async_xda_reads as pool_async_xda_reads, e.pool_data_writes - s.pool_data_writes as pool_data_writes, e.pool_async_data_writes - s.pool_async_data_writes as pool_async_data_writes, e.pool_data_lbp_pages_found - s.pool_data_lbp_pages_found as pool_data_lbp_pages_found, e.pool_async_data_lbp_pages_found - s.pool_async_data_lbp_pages_found as pool_async_data_lbp_pages_found, e.pool_temp_data_l_reads - s.pool_temp_data_l_reads as pool_temp_data_l_reads, e.pool_temp_data_p_reads - s.pool_temp_data_p_reads as pool_temp_data_p_reads, e.pool_index_lbp_pages_found - s.pool_index_lbp_pages_found as pool_index_lbp_pages_found, e.pool_async_index_lbp_pages_found - s.pool_async_index_lbp_pages_found as pool_async_index_lbp_pages_found, e.pool_temp_index_l_reads - s.pool_temp_index_l_reads as pool_temp_index_l_reads, e.pool_temp_index_p_reads - s.pool_temp_index_p_reads as pool_temp_index_p_reads, e.pool_write_time - s.pool_write_time as pool_write_time, e.pool_async_write_time - s.pool_async_write_time as pool_async_write_time, e.pool_index_l_reads - s.pool_index_l_reads as pool_index_l_reads, e.pool_index_p_reads - s.pool_index_p_reads as pool_index_p_reads, e.pool_index_writes - s.pool_index_writes as pool_index_writes, e.pool_async_index_writes - s.pool_async_index_writes as pool_async_index_writes, e.pool_xda_l_reads - s.pool_xda_l_reads as pool_xda_l_reads, e.pool_temp_xda_l_reads - s.pool_temp_xda_l_reads as pool_temp_xda_l_reads, e.pool_xda_p_reads - s.pool_xda_p_reads as pool_xda_p_reads, e.pool_temp_xda_p_reads - s.pool_temp_xda_p_reads as pool_temp_xda_p_reads, e.pool_xda_writes - s.pool_xda_writes as pool_xda_writes, e.pool_async_xda_writes - s.pool_async_xda_writes as pool_async_xda_writes from session.mon_get_bufferpool_start s, session.mon_get_bufferpool_end e where (s.member = e.member or (s.member is NULL and e.member is NULL)) and (s.bp_name = e.bp_name or (s.bp_name is NULL and e.bp_name is NULL)) with UR;
/* IBM_DB2MON */ insert into session.mon_get_bufferpool_diff select null, e.ts,e.member, e.bp_name, e.bp_cur_buffsz, e.automatic, e.pool_read_time, e.pool_data_l_reads, e.pool_data_p_reads, e.pool_async_read_time, e.pool_async_data_reads, e.pool_async_index_reads, e.pool_async_xda_reads, e.pool_data_writes, e.pool_async_data_writes, e.pool_data_lbp_pages_found, e.pool_async_data_lbp_pages_found, e.pool_temp_data_l_reads, e.pool_temp_data_p_reads, e.pool_index_lbp_pages_found, e.pool_async_index_lbp_pages_found, e.pool_temp_index_l_reads, e.pool_temp_index_p_reads, e.pool_write_time, e.pool_async_write_time, e.pool_index_l_reads, e.pool_index_p_reads, e.pool_index_writes, e.pool_async_index_writes, e.pool_xda_l_reads, e.pool_temp_xda_l_reads, e.pool_xda_p_reads, e.pool_temp_xda_p_reads, e.pool_xda_writes, e.pool_async_xda_writes from session.mon_get_bufferpool_end e where not exists ( select null from session.mon_get_bufferpool_start s where (s.member = e.member or (s.member is NULL and e.member is NULL)) and (s.bp_name = e.bp_name or (s.bp_name is NULL and e.bp_name is NULL)) ) with UR;
/* IBM_DB2MON */ update session.mon_get_bufferpool_diff set ts_delta = (select max(ts_delta) from session.mon_get_bufferpool_diff) where ts_delta is null;
/* IBM_DB2MON */ insert into session.mon_get_connection_diff select (((JULIAN_DAY(e.ts)-JULIAN_DAY(s.ts))*24 + (HOUR(e.ts)-HOUR(s.ts)))*60 + (MINUTE(e.ts)-MINUTE(s.ts)))*60 + (SECOND(e.ts)-SECOND(s.ts)),e.ts,s.member, s.application_name, s.application_handle, s.client_applname, e.client_idle_wait_time - s.client_idle_wait_time as client_idle_wait_time, e.total_rqst_time - s.total_rqst_time as total_rqst_time, e.rqsts_completed_total - s.rqsts_completed_total as rqsts_completed_total, e.total_wait_time - s.total_wait_time as total_wait_time, e.lock_wait_time - s.lock_wait_time as lock_wait_time, e.log_disk_wait_time - s.log_disk_wait_time as log_disk_wait_time, e.fcm_recv_wait_time - s.fcm_recv_wait_time as fcm_recv_wait_time, e.fcm_send_wait_time - s.fcm_send_wait_time as fcm_send_wait_time, e.pool_write_time - s.pool_write_time as pool_write_time, e.pool_read_time - s.pool_read_time as pool_read_time, e.direct_write_time - s.direct_write_time as direct_write_time, e.direct_read_time - s.direct_read_time as direct_read_time, e.total_section_sort_time - s.total_section_sort_time as total_section_sort_time, e.total_commit_time - s.total_commit_time as total_commit_time, e.total_runstats_time - s.total_runstats_time as total_runstats_time, e.total_reorg_time - s.total_reorg_time as total_reorg_time, e.total_load_time - s.total_load_time as total_load_time, e.total_app_commits - s.total_app_commits as total_app_commits, e.total_app_rollbacks - s.total_app_rollbacks as total_app_rollbacks, e.deadlocks - s.deadlocks as deadlocks, e.rows_modified - s.rows_modified as rows_modified, e.rows_read - s.rows_read as rows_read, e.rows_returned - s.rows_returned as rows_returned, e.total_sorts - s.total_sorts as total_sorts, e.total_reorgs - s.total_reorgs as total_reorgs, e.total_loads - s.total_loads as total_loads, e.total_runstats - s.total_runstats as total_runstats, e.pool_data_l_reads - s.pool_data_l_reads as pool_data_l_reads, e.pool_data_p_reads - s.pool_data_p_reads as pool_data_p_reads, e.pool_index_l_reads - s.pool_index_l_reads as pool_index_l_reads, e.pool_index_p_reads - s.pool_index_p_reads as pool_index_p_reads, e.ida_send_wait_time - s.ida_send_wait_time as ida_send_wait_time, e.ida_recv_wait_time - s.ida_recv_wait_time as ida_recv_wait_time from session.mon_get_connection_start s, session.mon_get_connection_end e where (s.member = e.member or (s.member is NULL and e.member is NULL)) and (s.application_name = e.application_name or (s.application_name is NULL and e.application_name is NULL)) and (s.application_handle = e.application_handle or (s.application_handle is NULL and e.application_handle is NULL)) and (s.client_applname = e.client_applname or (s.client_applname is NULL and e.client_applname is NULL)) with UR;
/* IBM_DB2MON */ insert into session.mon_get_connection_diff select null, e.ts,e.member, e.application_name, e.application_handle, e.client_applname, e.client_idle_wait_time, e.total_rqst_time, e.rqsts_completed_total, e.total_wait_time, e.lock_wait_time, e.log_disk_wait_time, e.fcm_recv_wait_time, e.fcm_send_wait_time, e.pool_write_time, e.pool_read_time, e.direct_write_time, e.direct_read_time, e.total_section_sort_time, e.total_commit_time, e.total_runstats_time, e.total_reorg_time, e.total_load_time, e.total_app_commits, e.total_app_rollbacks, e.deadlocks, e.rows_modified, e.rows_read, e.rows_returned, e.total_sorts, e.total_reorgs, e.total_loads, e.total_runstats, e.pool_data_l_reads, e.pool_data_p_reads, e.pool_index_l_reads, e.pool_index_p_reads, e.ida_send_wait_time, e.ida_recv_wait_time from session.mon_get_connection_end e where not exists ( select null from session.mon_get_connection_start s where (s.member = e.member or (s.member is NULL and e.member is NULL)) and (s.application_name = e.application_name or (s.application_name is NULL and e.application_name is NULL)) and (s.application_handle = e.application_handle or (s.application_handle is NULL and e.application_handle is NULL)) and (s.client_applname = e.client_applname or (s.client_applname is NULL and e.client_applname is NULL)) ) with UR;
/* IBM_DB2MON */ update session.mon_get_connection_diff set ts_delta = (select max(ts_delta) from session.mon_get_connection_diff) where ts_delta is null;
/* IBM_DB2MON */ insert into session.mon_get_index_diff select (((JULIAN_DAY(e.ts)-JULIAN_DAY(s.ts))*24 + (HOUR(e.ts)-HOUR(s.ts)))*60 + (MINUTE(e.ts)-MINUTE(s.ts)))*60 + (SECOND(e.ts)-SECOND(s.ts)),e.ts,s.member, s.tabschema, s.tabname, s.iid, s.data_partition_id, e.nleaf - s.nleaf as nleaf, e.nlevels - s.nlevels as nlevels, e.index_scans - s.index_scans as index_scans, e.index_only_scans - s.index_only_scans as index_only_scans, e.key_updates - s.key_updates as key_updates, e.include_col_updates - s.include_col_updates as include_col_updates, e.pseudo_deletes - s.pseudo_deletes as pseudo_deletes, e.del_keys_cleaned - s.del_keys_cleaned as del_keys_cleaned, e.root_node_splits - s.root_node_splits as root_node_splits, e.int_node_splits - s.int_node_splits as int_node_splits, e.boundary_leaf_node_splits - s.boundary_leaf_node_splits as boundary_leaf_node_splits, e.nonboundary_leaf_node_splits - s.nonboundary_leaf_node_splits as nonboundary_leaf_node_splits, e.page_allocations - s.page_allocations as page_allocations, e.pseudo_empty_pages - s.pseudo_empty_pages as pseudo_empty_pages, e.empty_pages_reused - s.empty_pages_reused as empty_pages_reused, e.empty_pages_deleted - s.empty_pages_deleted as empty_pages_deleted, e.pages_merged - s.pages_merged as pages_merged from session.mon_get_index_start s, session.mon_get_index_end e where (s.member = e.member or (s.member is NULL and e.member is NULL)) and (s.tabschema = e.tabschema or (s.tabschema is NULL and e.tabschema is NULL)) and (s.tabname = e.tabname or (s.tabname is NULL and e.tabname is NULL)) and (s.iid = e.iid or (s.iid is NULL and e.iid is NULL)) and (s.data_partition_id = e.data_partition_id or (s.data_partition_id is NULL and e.data_partition_id is NULL)) with UR;
/* IBM_DB2MON */ insert into session.mon_get_index_diff select null, e.ts,e.member, e.tabschema, e.tabname, e.iid, e.data_partition_id, e.nleaf, e.nlevels, e.index_scans, e.index_only_scans, e.key_updates, e.include_col_updates, e.pseudo_deletes, e.del_keys_cleaned, e.root_node_splits, e.int_node_splits, e.boundary_leaf_node_splits, e.nonboundary_leaf_node_splits, e.page_allocations, e.pseudo_empty_pages, e.empty_pages_reused, e.empty_pages_deleted, e.pages_merged from session.mon_get_index_end e where not exists ( select null from session.mon_get_index_start s where (s.member = e.member or (s.member is NULL and e.member is NULL)) and (s.tabschema = e.tabschema or (s.tabschema is NULL and e.tabschema is NULL)) and (s.tabname = e.tabname or (s.tabname is NULL and e.tabname is NULL)) and (s.iid = e.iid or (s.iid is NULL and e.iid is NULL)) and (s.data_partition_id = e.data_partition_id or (s.data_partition_id is NULL and e.data_partition_id is NULL)) ) with UR;
/* IBM_DB2MON */ update session.mon_get_index_diff set ts_delta = (select max(ts_delta) from session.mon_get_index_diff) where ts_delta is null;
/* IBM_DB2MON */ insert into session.mon_get_pkg_cache_stmt_diff select (((JULIAN_DAY(e.ts)-JULIAN_DAY(s.ts))*24 + (HOUR(e.ts)-HOUR(s.ts)))*60 + (MINUTE(e.ts)-MINUTE(s.ts)))*60 + (SECOND(e.ts)-SECOND(s.ts)),e.ts,s.member, s.executable_id, s.package_name, s.stmt_text, s.effective_isolation, e.num_exec_with_metrics - s.num_exec_with_metrics as num_exec_with_metrics, e.coord_stmt_exec_time - s.coord_stmt_exec_time as coord_stmt_exec_time, e.total_act_time - s.total_act_time as total_act_time, e.total_cpu_time - s.total_cpu_time as total_cpu_time, e.total_act_wait_time - s.total_act_wait_time as total_act_wait_time, e.lock_wait_time - s.lock_wait_time as lock_wait_time, e.log_disk_wait_time - s.log_disk_wait_time as log_disk_wait_time, e.log_buffer_wait_time - s.log_buffer_wait_time as log_buffer_wait_time, e.pool_write_time - s.pool_write_time as pool_write_time, e.pool_read_time - s.pool_read_time as pool_read_time, e.direct_write_time - s.direct_write_time as direct_write_time, e.direct_read_time - s.direct_read_time as direct_read_time, e.rows_modified - s.rows_modified as rows_modified, e.rows_read - s.rows_read as rows_read, e.rows_returned - s.rows_returned as rows_returned, e.total_sorts - s.total_sorts as total_sorts, e.sort_overflows - s.sort_overflows as sort_overflows, e.total_section_time - s.total_section_time as total_section_time, e.total_section_sort_time - s.total_section_sort_time as total_section_sort_time, e.pool_data_l_reads - s.pool_data_l_reads as pool_data_l_reads, e.pool_index_l_reads - s.pool_index_l_reads as pool_index_l_reads, e.pool_data_p_reads - s.pool_data_p_reads as pool_data_p_reads, e.pool_index_p_reads - s.pool_index_p_reads as pool_index_p_reads, e.pool_data_writes - s.pool_data_writes as pool_data_writes, e.pool_index_writes - s.pool_index_writes as pool_index_writes, e.pool_temp_data_p_reads - s.pool_temp_data_p_reads as pool_temp_data_p_reads, e.pool_temp_index_p_reads - s.pool_temp_index_p_reads as pool_temp_index_p_reads, e.direct_read_reqs - s.direct_read_reqs as direct_read_reqs, e.direct_write_reqs - s.direct_write_reqs as direct_write_reqs, e.ida_send_wait_time - s.ida_send_wait_time as ida_send_wait_time, e.ida_recv_wait_time - s.ida_recv_wait_time as ida_recv_wait_time from session.mon_get_pkg_cache_stmt_start s, session.mon_get_pkg_cache_stmt_end e where (s.member = e.member or (s.member is NULL and e.member is NULL)) and (s.executable_id = e.executable_id or (s.executable_id is NULL and e.executable_id is NULL)) with UR;
/* IBM_DB2MON */ insert into session.mon_get_pkg_cache_stmt_diff select null, e.ts,e.member, e.executable_id, e.package_name, e.stmt_text, e.effective_isolation, e.num_exec_with_metrics, e.coord_stmt_exec_time, e.total_act_time, e.total_cpu_time, e.total_act_wait_time, e.lock_wait_time, e.log_disk_wait_time, e.log_buffer_wait_time, e.pool_write_time, e.pool_read_time, e.direct_write_time, e.direct_read_time, e.rows_modified, e.rows_read, e.rows_returned, e.total_sorts, e.sort_overflows, e.total_section_time, e.total_section_sort_time, e.pool_data_l_reads, e.pool_index_l_reads, e.pool_data_p_reads, e.pool_index_p_reads, e.pool_data_writes, e.pool_index_writes, e.pool_temp_data_p_reads, e.pool_temp_index_p_reads, e.direct_read_reqs, e.direct_write_reqs, e.ida_send_wait_time, e.ida_recv_wait_time from session.mon_get_pkg_cache_stmt_end e where not exists ( select null from session.mon_get_pkg_cache_stmt_start s where (s.member = e.member or (s.member is NULL and e.member is NULL)) and (s.executable_id = e.executable_id or (s.executable_id is NULL and e.executable_id is NULL)) ) with UR;
/* IBM_DB2MON */ update session.mon_get_pkg_cache_stmt_diff set ts_delta = (select max(ts_delta) from session.mon_get_pkg_cache_stmt_diff) where ts_delta is null;
/* IBM_DB2MON */ create index session.idx_mon_get_pkg_cache_stmt_diff on session.mon_get_pkg_cache_stmt_diff (member, executable_id);
/* IBM_DB2MON */ insert into session.mon_get_table_diff select (((JULIAN_DAY(e.ts)-JULIAN_DAY(s.ts))*24 + (HOUR(e.ts)-HOUR(s.ts)))*60 + (MINUTE(e.ts)-MINUTE(s.ts)))*60 + (SECOND(e.ts)-SECOND(s.ts)),e.ts,s.member, s.tabname, s.tabschema, s.data_partition_id, s.tbsp_id, s.tab_file_id, e.rows_read - s.rows_read as rows_read, e.rows_inserted - s.rows_inserted as rows_inserted, e.rows_updated - s.rows_updated as rows_updated, e.rows_deleted - s.rows_deleted as rows_deleted, e.overflow_accesses - s.overflow_accesses as overflow_accesses, e.overflow_creates - s.overflow_creates as overflow_creates, e.page_reorgs - s.page_reorgs as page_reorgs from session.mon_get_table_start s, session.mon_get_table_end e where (s.member = e.member or (s.member is NULL and e.member is NULL)) and (s.tabname = e.tabname or (s.tabname is NULL and e.tabname is NULL)) and (s.tabschema = e.tabschema or (s.tabschema is NULL and e.tabschema is NULL)) and (s.data_partition_id = e.data_partition_id or (s.data_partition_id is NULL and e.data_partition_id is NULL)) and (s.tbsp_id = e.tbsp_id or (s.tbsp_id is NULL and e.tbsp_id is NULL)) and (s.tab_file_id = e.tab_file_id or (s.tab_file_id is NULL and e.tab_file_id is NULL)) with UR;
/* IBM_DB2MON */ insert into session.mon_get_table_diff select null, e.ts,e.member, e.tabname, e.tabschema, e.data_partition_id, e.tbsp_id, e.tab_file_id, e.rows_read, e.rows_inserted, e.rows_updated, e.rows_deleted, e.overflow_accesses, e.overflow_creates, e.page_reorgs from session.mon_get_table_end e where not exists ( select null from session.mon_get_table_start s where (s.member = e.member or (s.member is NULL and e.member is NULL)) and (s.tabname = e.tabname or (s.tabname is NULL and e.tabname is NULL)) and (s.tabschema = e.tabschema or (s.tabschema is NULL and e.tabschema is NULL)) and (s.data_partition_id = e.data_partition_id or (s.data_partition_id is NULL and e.data_partition_id is NULL)) and (s.tbsp_id = e.tbsp_id or (s.tbsp_id is NULL and e.tbsp_id is NULL)) and (s.tab_file_id = e.tab_file_id or (s.tab_file_id is NULL and e.tab_file_id is NULL)) ) with UR;
/* IBM_DB2MON */ update session.mon_get_table_diff set ts_delta = (select max(ts_delta) from session.mon_get_table_diff) where ts_delta is null;
/* IBM_DB2MON */ create index session.idx_mon_get_table_diff on session.mon_get_table_diff (member, tabname, tabschema, data_partition_id, tbsp_id, tab_file_id);
/* IBM_DB2MON */ insert into session.mon_get_tablespace_diff select (((JULIAN_DAY(e.ts)-JULIAN_DAY(s.ts))*24 + (HOUR(e.ts)-HOUR(s.ts)))*60 + (MINUTE(e.ts)-MINUTE(s.ts)))*60 + (SECOND(e.ts)-SECOND(s.ts)),e.ts,s.member, s.tbsp_name, s.tbsp_page_size, s.tbsp_id, s.tbsp_extent_size, s.tbsp_prefetch_size, s.fs_caching, e.pool_read_time - s.pool_read_time as pool_read_time, e.pool_async_read_time - s.pool_async_read_time as pool_async_read_time, e.pool_write_time - s.pool_write_time as pool_write_time, e.pool_async_write_time - s.pool_async_write_time as pool_async_write_time, e.pool_data_writes - s.pool_data_writes as pool_data_writes, e.pool_async_data_writes - s.pool_async_data_writes as pool_async_data_writes, e.pool_index_writes - s.pool_index_writes as pool_index_writes, e.pool_async_index_writes - s.pool_async_index_writes as pool_async_index_writes, e.pool_data_l_reads - s.pool_data_l_reads as pool_data_l_reads, e.pool_temp_data_l_reads - s.pool_temp_data_l_reads as pool_temp_data_l_reads, e.pool_async_data_reads - s.pool_async_data_reads as pool_async_data_reads, e.pool_data_p_reads - s.pool_data_p_reads as pool_data_p_reads, e.pool_temp_data_p_reads - s.pool_temp_data_p_reads as pool_temp_data_p_reads, e.pool_async_index_reads - s.pool_async_index_reads as pool_async_index_reads, e.pool_index_l_reads - s.pool_index_l_reads as pool_index_l_reads, e.pool_temp_index_l_reads - s.pool_temp_index_l_reads as pool_temp_index_l_reads, e.pool_index_p_reads - s.pool_index_p_reads as pool_index_p_reads, e.pool_temp_index_p_reads - s.pool_temp_index_p_reads as pool_temp_index_p_reads, e.pool_xda_l_reads - s.pool_xda_l_reads as pool_xda_l_reads, e.pool_temp_xda_l_reads - s.pool_temp_xda_l_reads as pool_temp_xda_l_reads, e.pool_async_xda_reads - s.pool_async_xda_reads as pool_async_xda_reads, e.pool_xda_p_reads - s.pool_xda_p_reads as pool_xda_p_reads, e.pool_temp_xda_p_reads - s.pool_temp_xda_p_reads as pool_temp_xda_p_reads, e.pool_xda_writes - s.pool_xda_writes as pool_xda_writes, e.pool_async_xda_writes - s.pool_async_xda_writes as pool_async_xda_writes, e.unread_prefetch_pages - s.unread_prefetch_pages as unread_prefetch_pages, e.vectored_ios - s.vectored_ios as vectored_ios, e.pages_from_vectored_ios - s.pages_from_vectored_ios as pages_from_vectored_ios, e.block_ios - s.block_ios as block_ios, e.pages_from_block_ios - s.pages_from_block_ios as pages_from_block_ios, e.pool_data_lbp_pages_found - s.pool_data_lbp_pages_found as pool_data_lbp_pages_found, e.pool_index_lbp_pages_found - s.pool_index_lbp_pages_found as pool_index_lbp_pages_found, e.pool_async_data_lbp_pages_found - s.pool_async_data_lbp_pages_found as pool_async_data_lbp_pages_found, e.pool_async_index_lbp_pages_found - s.pool_async_index_lbp_pages_found as pool_async_index_lbp_pages_found, e.direct_read_reqs - s.direct_read_reqs as direct_read_reqs, e.direct_write_reqs - s.direct_write_reqs as direct_write_reqs, e.direct_read_time - s.direct_read_time as direct_read_time, e.direct_write_time - s.direct_write_time as direct_write_time, e.tbsp_used_pages - s.tbsp_used_pages as tbsp_used_pages, e.tbsp_page_top - s.tbsp_page_top as tbsp_page_top from session.mon_get_tablespace_start s, session.mon_get_tablespace_end e where (s.member = e.member or (s.member is NULL and e.member is NULL)) and (s.tbsp_name = e.tbsp_name or (s.tbsp_name is NULL and e.tbsp_name is NULL)) with UR;
/* IBM_DB2MON */ insert into session.mon_get_tablespace_diff select null, e.ts,e.member, e.tbsp_name, e.tbsp_page_size, e.tbsp_id, e.tbsp_extent_size, e.tbsp_prefetch_size, e.fs_caching, e.pool_read_time, e.pool_async_read_time, e.pool_write_time, e.pool_async_write_time, e.pool_data_writes, e.pool_async_data_writes, e.pool_index_writes, e.pool_async_index_writes, e.pool_data_l_reads, e.pool_temp_data_l_reads, e.pool_async_data_reads, e.pool_data_p_reads, e.pool_temp_data_p_reads, e.pool_async_index_reads, e.pool_index_l_reads, e.pool_temp_index_l_reads, e.pool_index_p_reads, e.pool_temp_index_p_reads, e.pool_xda_l_reads, e.pool_temp_xda_l_reads, e.pool_async_xda_reads, e.pool_xda_p_reads, e.pool_temp_xda_p_reads, e.pool_xda_writes, e.pool_async_xda_writes, e.unread_prefetch_pages, e.vectored_ios, e.pages_from_vectored_ios, e.block_ios, e.pages_from_block_ios, e.pool_data_lbp_pages_found, e.pool_index_lbp_pages_found, e.pool_async_data_lbp_pages_found, e.pool_async_index_lbp_pages_found, e.direct_read_reqs, e.direct_write_reqs, e.direct_read_time, e.direct_write_time, e.tbsp_used_pages, e.tbsp_page_top from session.mon_get_tablespace_end e where not exists ( select null from session.mon_get_tablespace_start s where (s.member = e.member or (s.member is NULL and e.member is NULL)) and (s.tbsp_name = e.tbsp_name or (s.tbsp_name is NULL and e.tbsp_name is NULL)) ) with UR;
/* IBM_DB2MON */ update session.mon_get_tablespace_diff set ts_delta = (select max(ts_delta) from session.mon_get_tablespace_diff) where ts_delta is null;
/* IBM_DB2MON */ insert into session.mon_get_workload_diff select (((JULIAN_DAY(e.ts)-JULIAN_DAY(s.ts))*24 + (HOUR(e.ts)-HOUR(s.ts)))*60 + (MINUTE(e.ts)-MINUTE(s.ts)))*60 + (SECOND(e.ts)-SECOND(s.ts)),e.ts,s.member, s.workload_name, e.act_completed_total - s.act_completed_total as act_completed_total, e.total_act_time - s.total_act_time as total_act_time, e.total_rqst_time - s.total_rqst_time as total_rqst_time, e.total_wait_time - s.total_wait_time as total_wait_time, e.lock_wait_time - s.lock_wait_time as lock_wait_time, e.log_disk_wait_time - s.log_disk_wait_time as log_disk_wait_time, e.pool_write_time - s.pool_write_time as pool_write_time, e.pool_read_time - s.pool_read_time as pool_read_time, e.direct_write_time - s.direct_write_time as direct_write_time, e.direct_read_time - s.direct_read_time as direct_read_time, e.tcpip_recv_wait_time - s.tcpip_recv_wait_time as tcpip_recv_wait_time, e.tcpip_send_wait_time - s.tcpip_send_wait_time as tcpip_send_wait_time, e.fcm_recv_wait_time - s.fcm_recv_wait_time as fcm_recv_wait_time, e.fcm_send_wait_time - s.fcm_send_wait_time as fcm_send_wait_time, e.total_cpu_time - s.total_cpu_time as total_cpu_time, e.total_compile_time - s.total_compile_time as total_compile_time, e.total_compile_proc_time - s.total_compile_proc_time as total_compile_proc_time, e.total_routine_time - s.total_routine_time as total_routine_time, e.total_section_sort_time - s.total_section_sort_time as total_section_sort_time, e.total_section_sort_proc_time - s.total_section_sort_proc_time as total_section_sort_proc_time, e.total_section_time - s.total_section_time as total_section_time, e.total_section_proc_time - s.total_section_proc_time as total_section_proc_time, e.total_commit_time - s.total_commit_time as total_commit_time, e.total_rollback_time - s.total_rollback_time as total_rollback_time, e.total_runstats_time - s.total_runstats_time as total_runstats_time, e.total_reorg_time - s.total_reorg_time as total_reorg_time, e.total_load_time - s.total_load_time as total_load_time, e.total_app_commits - s.total_app_commits as total_app_commits, e.total_app_rollbacks - s.total_app_rollbacks as total_app_rollbacks, e.deadlocks - s.deadlocks as deadlocks, e.lock_timeouts - s.lock_timeouts as lock_timeouts, e.lock_escals - s.lock_escals as lock_escals, e.client_idle_wait_time - s.client_idle_wait_time as client_idle_wait_time, e.rows_modified - s.rows_modified as rows_modified, e.rows_read - s.rows_read as rows_read, e.rows_returned - s.rows_returned as rows_returned, e.pkg_cache_inserts - s.pkg_cache_inserts as pkg_cache_inserts, e.total_sorts - s.total_sorts as total_sorts, e.sort_overflows - s.sort_overflows as sort_overflows, e.post_threshold_sorts - s.post_threshold_sorts as post_threshold_sorts, e.post_shrthreshold_sorts - s.post_shrthreshold_sorts as post_shrthreshold_sorts, e.total_reorgs - s.total_reorgs as total_reorgs, e.total_loads - s.total_loads as total_loads, e.total_runstats - s.total_runstats as total_runstats, e.pool_data_l_reads - s.pool_data_l_reads as pool_data_l_reads, e.pool_data_p_reads - s.pool_data_p_reads as pool_data_p_reads, e.pool_temp_data_p_reads - s.pool_temp_data_p_reads as pool_temp_data_p_reads, e.pool_index_l_reads - s.pool_index_l_reads as pool_index_l_reads, e.pool_index_p_reads - s.pool_index_p_reads as pool_index_p_reads, e.pool_temp_index_p_reads - s.pool_temp_index_p_reads as pool_temp_index_p_reads, e.pool_xda_p_reads - s.pool_xda_p_reads as pool_xda_p_reads, e.pool_temp_xda_p_reads - s.pool_temp_xda_p_reads as pool_temp_xda_p_reads, e.ida_send_wait_time - s.ida_send_wait_time as ida_send_wait_time, e.ida_recv_wait_time - s.ida_recv_wait_time as ida_recv_wait_time from session.mon_get_workload_start s, session.mon_get_workload_end e where (s.member = e.member or (s.member is NULL and e.member is NULL)) and (s.workload_name = e.workload_name or (s.workload_name is NULL and e.workload_name is NULL)) with UR;
/* IBM_DB2MON */ insert into session.mon_get_workload_diff select null, e.ts,e.member, e.workload_name, e.act_completed_total, e.total_act_time, e.total_rqst_time, e.total_wait_time, e.lock_wait_time, e.log_disk_wait_time, e.pool_write_time, e.pool_read_time, e.direct_write_time, e.direct_read_time, e.tcpip_recv_wait_time, e.tcpip_send_wait_time, e.fcm_recv_wait_time, e.fcm_send_wait_time, e.total_cpu_time, e.total_compile_time, e.total_compile_proc_time, e.total_routine_time, e.total_section_sort_time, e.total_section_sort_proc_time, e.total_section_time, e.total_section_proc_time, e.total_commit_time, e.total_rollback_time, e.total_runstats_time, e.total_reorg_time, e.total_load_time, e.total_app_commits, e.total_app_rollbacks, e.deadlocks, e.lock_timeouts, e.lock_escals, e.client_idle_wait_time, e.rows_modified, e.rows_read, e.rows_returned, e.pkg_cache_inserts, e.total_sorts, e.sort_overflows, e.post_threshold_sorts, e.post_shrthreshold_sorts, e.total_reorgs, e.total_loads, e.total_runstats, e.pool_data_l_reads, e.pool_data_p_reads, e.pool_temp_data_p_reads, e.pool_index_l_reads, e.pool_index_p_reads, e.pool_temp_index_p_reads, e.pool_xda_p_reads, e.pool_temp_xda_p_reads, e.ida_send_wait_time, e.ida_recv_wait_time from session.mon_get_workload_end e where not exists ( select null from session.mon_get_workload_start s where (s.member = e.member or (s.member is NULL and e.member is NULL)) and (s.workload_name = e.workload_name or (s.workload_name is NULL and e.workload_name is NULL)) ) with UR;
/* IBM_DB2MON */ update session.mon_get_workload_diff set ts_delta = (select max(ts_delta) from session.mon_get_workload_diff) where ts_delta is null;
/* IBM_DB2MON */ commit work;
/* IBM_DB2MON */ set current schema session;
echo REPORT STARTS HERE;
echo;

echo ################################################################################################################### ;
echo  Point-in-time data: Current executing SQL, lock waits and utilities at start of capture ;
echo ################################################################################################################### ;
echo;

/* IBM_DB2MON */
select min(ts) capture_time from mon_current_sql_plus_start;

echo ================================================================================= ;
echo  START#EXSQL: Currently executing SQL at start of capture (non-zero metrics only  ;
echo ================================================================================= ;
echo ;

with /* IBM_DB2MON */ mon as (select ts,

coord_member,application_handle,elapsed_time_sec,total_cpu_time,rows_read,direct_reads,direct_writes,stmt_text
from
  mon_current_sql_plus_start )
select
  t.metric "Metric", t.value "Value"
from
  mon,
  table( values
    ('COORD_MEMBER',varchar(coord_member)),
    ('STMT_TEXT', cast(substr(stmt_text,1,120) as varchar(120))),
    ('APPLICATION_HANDLE',varchar(application_handle)),
    ('ELAPSED_TIME_SEC',varchar(elapsed_time_sec)),
    ('TOTAL_CPU_TIME',varchar(total_cpu_time)),
    ('ROWS_READ',varchar(rows_read)),
    ('DIRECT_READS',varchar(direct_reads)),
    ('DIRECT_WRITES',varchar(direct_writes)),
    (cast(repeat('-',32) as varchar(32)),cast(repeat('-',120) as varchar(120))) )
  as t(metric,value)
  where t.metric = 'COORD_MEMBER' or t.value <> '0'
  order by elapsed_time_sec desc
with UR;

echo ===================================================== ;
echo  START#LOCKW: Current lock waits at start of capture  ;
echo ===================================================== ;
echo ;

/* IBM_DB2MON */
select
(select cast(substr(tbspace,1,20) as varchar(20)) from syscat.tablespaces where tbspaceid = tbsp_id) tbspace,
(select cast(substr(tabname,1,30) as varchar(30)) from syscat.tables where tab_file_id = tableid and tbspaceid = tbsp_id) tabname,
  cast(substr(lock_object_type,1,12) as varchar(12)) lock_obj_type,
  lock_name,
  lock_mode,
  lock_status,
  member,
  integer(application_handle) apphdl
from
  mon_get_locks_start
where
  lock_name in (select lock_name from mon_get_locks_start where lock_status = 'W')
order by
  lock_object_type, lock_name, lock_status, lock_mode
with UR;


echo ################################################################################################################### ;
echo  Point-in-time data: Current executing SQL, lock waits and utilities at end of capture ;
echo ################################################################################################################### ;
echo;

/* IBM_DB2MON */
select min(ts) capture_time from mon_current_sql_plus_end;

echo ============================================================================= ;
echo  END#EXSQL: Currently executing SQL at end of capture (non-zero metrics only  ;
echo ============================================================================= ;
echo ;

with /* IBM_DB2MON */ mon as (select ts,

coord_member,application_handle,elapsed_time_sec,total_cpu_time,rows_read,direct_reads,direct_writes,stmt_text
from
  mon_current_sql_plus_end )
select
  t.metric "Metric", t.value "Value"
from
  mon,
  table( values
    ('COORD_MEMBER',varchar(coord_member)),
    ('STMT_TEXT', cast(substr(stmt_text,1,120) as varchar(120))),
    ('APPLICATION_HANDLE',varchar(application_handle)),
    ('ELAPSED_TIME_SEC',varchar(elapsed_time_sec)),
    ('TOTAL_CPU_TIME',varchar(total_cpu_time)),
    ('ROWS_READ',varchar(rows_read)),
    ('DIRECT_READS',varchar(direct_reads)),
    ('DIRECT_WRITES',varchar(direct_writes)),
    (cast(repeat('-',32) as varchar(32)),cast(repeat('-',120) as varchar(120))) )
  as t(metric,value)
  where t.metric = 'COORD_MEMBER' or t.value <> '0'
  order by elapsed_time_sec desc
with UR;

echo ================================================= ;
echo  END#LOCKW: Current lock waits at end of capture  ;
echo ================================================= ;
echo ;

/* IBM_DB2MON */
select
(select cast(substr(tbspace,1,20) as varchar(20)) from syscat.tablespaces where tbspaceid = tbsp_id) tbspace,
(select cast(substr(tabname,1,30) as varchar(30)) from syscat.tables where tab_file_id = tableid and tbspaceid = tbsp_id) tabname,
  cast(substr(lock_object_type,1,12) as varchar(12)) lock_obj_type,
  lock_name,
  lock_mode,
  lock_status,
  member,
  integer(application_handle) apphdl
from
  mon_get_locks_end
where
  lock_name in (select lock_name from mon_get_locks_end where lock_status = 'W')
order by
  lock_object_type, lock_name, lock_status, lock_mode
with UR;


echo ################################################################################################################### ;
echo  Data collected from start to end of monitor interval;
echo ################################################################################################################### ;
echo;
echo ================================================ ;
echo  DB#THRUP: Throughput metrics at database level  ;
echo ================================================ ;
echo ;

/* IBM_DB2MON */
select
   min(ts_delta) ts_delta,
   member,
   decimal((sum(act_completed_total) / float(min(ts_delta))), 10, 1) as act_per_s,
   decimal((sum(total_app_commits) / float(min(ts_delta))), 10, 1) as cmt_per_s,
   decimal((sum(total_app_rollbacks) / float(min(ts_delta))), 10, 1) as rb_per_s,
   decimal((sum(deadlocks) / float(min(ts_delta))), 10, 1) as ddlck_per_s,


   decimal((sum(rows_returned) / float(min(ts_delta))), 10, 1) as rows_ret_p_s,
   decimal((sum(rows_modified) / float(min(ts_delta))), 10, 1) as rows_mod_p_s,
   decimal((sum(pkg_cache_inserts) / float(min(ts_delta))), 10, 1) as pkg_cache_ins_p_s,
   decimal((sum((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads)) / float(min(ts_delta))) , 10, 1) as p_rd_per_s
from
   mon_get_workload_diff
where
   ts_delta > 0
group by
   member
order by
   member asc
with UR;

echo ======================================================================= ;
echo  DB#CLACT: Client activity (active connections have at least 1 stmt/s)  ;
echo ======================================================================= ;
echo ;

with
/* IBM_DB2MON */
   total_clients as
       (  select
             member,
             count(*) count,
             sum(client_idle_wait_time) client_idle_wait_time,
             sum(total_rqst_time) total_rqst_time,
             case when sum(total_rqst_time) > 0 then decimal(float(sum(client_idle_wait_time)) / sum(total_rqst_time), 10, 2) else null end as idle_rqst_ratio
          from
             mon_get_connection_diff
          group by
             member
       ),
   active_clients as
       (  select
             member,
             count(*) count,
             decimal(float(sum(rqsts_completed_total)) / min(ts_delta), 10, 2) rqst_per_s,
             sum(client_idle_wait_time) client_idle_wait_time,
             sum(total_rqst_time) total_rqst_time,
             case when sum(total_rqst_time) > 0 then decimal(float(sum(client_idle_wait_time)) / sum(total_rqst_time), 10, 2) else null end as idle_rqst_ratio
          from
             mon_get_connection_diff
          where
             rqsts_completed_total >= ts_delta or                                       -- At least one request per second, or ...
             (total_rqst_time > 0 and client_idle_wait_time / total_rqst_time < 2)      -- long requests, at least half as long as the client idle wait time
          group by
             member
       )
select
   t.member,
   t.count as total_clients,
   t.client_idle_wait_time total_ciwt,
   t.total_rqst_time total_rqst,
   t.idle_rqst_ratio tot_ciwt_rq_ratio,
   a.count as active_clients,
   a.rqst_per_s active_rq_per_s,
   a.client_idle_wait_time active_ciwt,
   a.total_rqst_time active_rqst,
   a.idle_rqst_ratio active_ciwt_rq_ratio
from
   total_clients t,
   active_clients a
where
   a.member = t.member
with UR;

echo ================================================================ ;
echo  DB#TIMEB: Time breakdown at database level (wait + processing)  ;
echo ================================================================ ;
echo ;

/* IBM_DB2MON */
select
   member,
   integer(sum(total_rqst_time)) as total_rqst_tm,
   decimal(sum(total_compile_time) / float(sum(total_rqst_time)) * 100, 5, 2) as pct_compile,
   decimal(sum(total_section_time) / float(sum(total_rqst_time)) * 100, 5, 2) as pct_section,
   decimal(sum(total_section_sort_time) / float(sum(total_rqst_time)) * 100, 5, 2) as pct_sort,
decimal(sum(total_commit_time) / float(sum(total_rqst_time)) * 100, 5, 2) as pct_commit,
decimal(sum(total_rollback_time) / float(sum(total_rqst_time)) * 100, 5, 2) as pct_rback,
   decimal(sum(total_runstats_time) / float(sum(total_rqst_time)) * 100, 5, 2) as pct_runstats,
   decimal(sum(total_reorg_time) / float(sum(total_rqst_time)) * 100, 5, 2) as pct_reorg,
   decimal(sum(total_load_time) / float(sum(total_rqst_time)) * 100, 5, 2) as pct_load

from
   mon_get_workload_diff
group by
   member
order by
   member asc
with UR;

echo ======================================== ;
echo  DB#WAITT: Wait times at database level  ;
echo ======================================== ;
echo ;

/* IBM_DB2MON */
select
   w.member,
   integer(sum(total_rqst_time)) as total_rqst_tm,
   integer(sum(total_wait_time)) as total_wait_tm,
   decimal((sum(total_wait_time) / float(sum(total_rqst_time))) * 100, 5, 2) as pct_rqst_wait,
   decimal((sum(lock_wait_time) / float(sum(total_rqst_time))) * 100, 5, 2) as pct_lock,
   decimal((sum(pool_read_time) / float(sum(total_rqst_time))) * 100, 5, 2) as pct_pool_r,
   decimal((sum(direct_read_time) / float(sum(total_rqst_time))) * 100, 5, 2) as pct_dir_r,
   decimal((sum(direct_write_time) / float(sum(total_rqst_time))) * 100, 5, 2) as pct_dir_w,
   decimal((sum(fcm_recv_wait_time + fcm_send_wait_time) / float(sum(total_rqst_time))) * 100, 5, 2) as pct_fcm,
   decimal((sum(tcpip_send_wait_time + tcpip_recv_wait_time) / float(sum(total_rqst_time))) * 100, 5, 2) as pct_tcpip,
   decimal((sum(ida_send_wait_time + ida_recv_wait_time) / double(sum(total_rqst_time))) * 100, 5, 2) as pct_ida
from
   mon_get_workload_diff w
group by
   w.member
order by
   w.member asc
with UR;

echo ============================================== ;
echo  DB#PROCT: Processing times at database level  ;
echo ============================================== ;
echo ;

/* IBM_DB2MON */
select
   member,
   integer(sum(total_rqst_time)) as total_rqst_tm,
   integer(sum(total_rqst_time) - sum(total_wait_time)) as total_proc_time,
   decimal(sum(total_compile_proc_time) / float(sum(total_rqst_time)) * 100, 5, 2) as pct_comp_proc,
   decimal(sum(total_section_proc_time) / float(sum(total_rqst_time)) * 100, 5, 2) as pct_sect_proc,
   decimal(sum(total_section_sort_proc_time) / float(sum(total_rqst_time)) * 100, 5, 2) as pct_sect_sort_proc,
   decimal(sum(total_commit_time) / float(sum(total_rqst_time)) * 100, 5, 2) as pct_commit,
   decimal(sum(total_rollback_time) / float(sum(total_rqst_time)) * 100, 5, 2) as pct_rback
from
   mon_get_workload_diff
group by
   member
order by
   member asc
with UR;

echo ========================================= ;
echo  DB#SORT: Sort metrics at database level  ;
echo ========================================= ;
echo ;

/* IBM_DB2MON */
select
   member,
   integer(sum(total_sorts)) total_sorts,
   integer(sum(sort_overflows)) sort_overflows,
   sum(total_section_sort_time) tot_sect_sort_tm,
   sum(total_section_sort_proc_time) tot_sect_sort_proc_tm
from
   mon_get_workload_diff
group by
   member
order by
   member asc
with UR;

echo ==================================================== ;
echo  SQL#TOPEXECT: Top SQL statements by execution time  ;
echo ==================================================== ;
echo ;

/* IBM_DB2MON */
select
   member,
   integer(num_exec_with_metrics) as num_exec,
   m.coord_stmt_exec_time,
   decimal(m.coord_stmt_exec_time / double(num_exec_with_metrics), 10, 2) as avg_coord_exec_time,
   decimal( (m.coord_stmt_exec_time / double(total_coord_stmt_exec_time)) * 100, 5, 2 ) as pct_coord_stmt_exec_time,
   m.total_act_time,
   total_cpu_time,
   total_cpu_time / num_exec_with_metrics as avg_cpu_time,
   case when total_act_time > 0
      then decimal( (total_act_wait_time / double(total_act_time)) * 100, 5, 2 )
      else 0
   end as pct_wait_time,
   decimal(total_section_time / double(num_exec_with_metrics), 20, 2) as avg_sect_time,
   effective_isolation as iso,
   replace(replace(cast(substr(stmt_text,1,200) as varchar(200)), chr(10), ' '), chr(13), ' ') as stmt_text
from
   mon_get_pkg_cache_stmt_diff m,
   (select sum(coord_stmt_exec_time) as total_coord_stmt_exec_time from mon_get_pkg_cache_stmt_diff where coord_stmt_exec_time > 0),
   (select executable_id, coord_stmt_exec_time
    from mon_get_pkg_cache_stmt_diff
    where coord_stmt_exec_time <> 0
    order by coord_stmt_exec_time desc
    fetch first 100 rows only) c
where
   (total_act_time <> 0 or m.coord_stmt_exec_time <> 0) and num_exec_with_metrics <> 0 and c.executable_id = m.executable_id
order by
   -- Order by c.coord_stmt_exec_time not m.coord_stmt_exec_time (c has coord value, m has member value which could be zero)
   -- Doing this has the nice effect of grouping member executions of the same statement together.
   c.coord_stmt_exec_time desc, total_act_time desc, member asc
with UR;

echo ============================================ ;
echo  PKG#EXECT: Time spent executing by package  ;
echo ============================================ ;
echo ;

/* IBM_DB2MON */
select
    member,
    cast(substr(package_name,1,20) as varchar(20)) as package_name,
    sum(num_exec_with_metrics) as num_stmts_exec,
    sum(coord_stmt_exec_time) as coord_stmt_exec_time
from
    mon_get_pkg_cache_stmt_diff
where
    coord_stmt_exec_time > 0
group by
    member, package_name
order by
    coord_stmt_exec_time desc
fetch first 100 rows only
with UR;

echo ============================================================================ ;
echo  SQL#TOPWAITT: Wait time breakdown for top SQL statements by execution time  ;
echo ============================================================================ ;
echo ;

/* IBM_DB2MON */
select
   member,
   decimal((total_act_wait_time / double(total_act_time)) * 100, 5, 2) as pct_wait,
   decimal((log_disk_wait_time / double(total_act_time)) * 100, 5, 2) as pct_lg_dsk,
   decimal((log_buffer_wait_time / double(total_act_time)) * 100, 5, 2) as pct_lg_buf,
   decimal((lock_wait_time / double(total_act_time)) * 100, 5, 2) as pct_lock,

   decimal((pool_read_time / double(total_act_time)) * 100, 5, 2) as pct_pool_r,
   decimal((direct_read_time / double(total_act_time)) * 100, 5, 2) as pct_dir_r,
   decimal((direct_write_time / double(total_act_time)) * 100, 5, 2) as pct_dir_w,


   decimal(((ida_send_wait_time + ida_recv_wait_time) / double(total_act_time)) * 100, 5, 2) as pct_ida,
   replace(replace(cast(substr(stmt_text,1,200) as varchar(200)), chr(10), ' '), chr(13), ' ') as stmt_text
from
   mon_get_pkg_cache_stmt_diff m,
   (select executable_id, coord_stmt_exec_time
    from mon_get_pkg_cache_stmt_diff
    where coord_stmt_exec_time <> 0
    order by coord_stmt_exec_time desc
    fetch first 100 rows only) c
where
   total_act_time <> 0 and num_exec_with_metrics <> 0 and c.executable_id = m.executable_id
order by
   c.coord_stmt_exec_time desc, total_act_time desc, member asc
with UR;

echo ======================================================== ;
echo  SQL#TOPWAITW: Top SQL statements by time spent waiting  ;
echo ======================================================== ;
echo ;

/* IBM_DB2MON */
select
   member,
   decimal((total_act_wait_time / double(total_act_time)) * 100, 5, 2) as pct_wait,
   decimal((log_disk_wait_time / double(total_act_time)) * 100, 5, 2) as pct_lg_dsk,
   decimal((log_buffer_wait_time / double(total_act_time)) * 100, 5, 2) as pct_lg_buf,
   decimal((lock_wait_time / double(total_act_time)) * 100, 5, 2) as pct_lock,


   decimal((pool_read_time / double(total_act_time)) * 100, 5, 2) as pct_pool_r,
   decimal((direct_read_time / double(total_act_time)) * 100, 5, 2) as pct_dir_r,
   decimal((direct_write_time / double(total_act_time)) * 100, 5, 2) as pct_dir_w,


   decimal(((ida_send_wait_time + ida_recv_wait_time) / double(total_act_time)) * 100, 5, 2) as pct_ida,
   replace(replace(cast(substr(stmt_text,1,200) as varchar(200)), chr(10), ' '), chr(13), ' ') as stmt_text
from
   mon_get_pkg_cache_stmt_diff m,
   (select executable_id, sum(total_act_wait_time) sum_members_total_act_wait_time
    from mon_get_pkg_cache_stmt_diff
		group by executable_id
    order by sum(total_act_wait_time) desc
    fetch first 100 rows only) c
where
   total_act_wait_time <> 0 and num_exec_with_metrics <> 0 and c.executable_id = m.executable_id
order by
   sum_members_total_act_wait_time desc, total_act_wait_time desc, member asc
with UR;

echo ========================================================================= ;
echo  SQL#TOPIOSTA: IO statistics per stmt - top statements by execution time  ;
echo ========================================================================= ;
echo ;

/* IBM_DB2MON */
select
   member,
   integer(num_exec_with_metrics) num_exec,
   decimal(pool_data_l_reads/double(num_exec_with_metrics), 16,1) as avg_d_lrd,
   decimal(pool_data_p_reads/double(num_exec_with_metrics), 10,1) as avg_d_prd,
   decimal(pool_index_l_reads/double(num_exec_with_metrics), 16,1) as avg_i_lrd,
   decimal(pool_index_p_reads/double(num_exec_with_metrics), 10,1) as avg_i_prd,
   decimal(pool_temp_data_p_reads/double(num_exec_with_metrics), 10,1) as avg_td_prd,
   decimal(pool_temp_index_p_reads/double(num_exec_with_metrics), 10,1) as avg_ti_prd,
   decimal(direct_read_reqs/double(num_exec_with_metrics), 8,1) avg_dir_r_rqs,
   decimal(direct_write_reqs/double(num_exec_with_metrics), 8,1) avg_dir_w_rqs,
   replace(replace(cast(substr(stmt_text,1,200) as varchar(200)), chr(10), ' '), chr(13), ' ') as stmt_text
from
   mon_get_pkg_cache_stmt_diff m,
   (select executable_id, coord_stmt_exec_time
    from mon_get_pkg_cache_stmt_diff
    where coord_stmt_exec_time <> 0
    order by coord_stmt_exec_time desc
    fetch first 100 rows only) c
where
   (total_act_time <> 0 or m.coord_stmt_exec_time <> 0) and num_exec_with_metrics <> 0 and c.executable_id = m.executable_id
order by
   c.coord_stmt_exec_time desc, total_act_time desc, member asc
with UR;

echo =============================================================================== ;
echo  SQL#TOPROWS: Row level statistics per stmt - top statements by execution time  ;
echo =============================================================================== ;
echo ;

/* IBM_DB2MON */
select
  member,
  integer(num_exec_with_metrics) as num_exec,
  decimal(rows_modified/double(num_exec_with_metrics), 12,1) as avg_rows_mod,
  decimal(rows_read/double(num_exec_with_metrics), 12,1) as avg_rows_read,
  decimal(rows_returned/double(num_exec_with_metrics), 12,1) as avg_rows_ret,
  replace(replace(cast(substr(stmt_text,1,200) as varchar(200)), chr(10), ' '), chr(13), ' ') as stmt_text
from
  mon_get_pkg_cache_stmt_diff m,
  (select executable_id, coord_stmt_exec_time
   from mon_get_pkg_cache_stmt_diff
   where coord_stmt_exec_time <> 0
   order by coord_stmt_exec_time desc
   fetch first 100 rows only) c
where
  (total_act_time <> 0 or m.coord_stmt_exec_time <> 0) and num_exec_with_metrics <> 0 and c.executable_id = m.executable_id
order by
  c.coord_stmt_exec_time desc, total_act_time desc, member asc
with UR;

echo ========================================================================== ;
echo  SQL#TOPSORT: Sort statistics per stmt - top statements by execution time  ;
echo ========================================================================== ;
echo ;

/* IBM_DB2MON */
select
  member,
  case when total_act_time > 0
    then decimal((total_section_sort_time / double(total_act_time)) * 100, 5, 2)
    else 0
  end as pct_sort_time,
  decimal(total_sorts / double(num_exec_with_metrics), 8,1) as avg_tot_sorts,
  decimal(sort_overflows / double(num_exec_with_metrics), 8,1) as avg_sort_ovflws,
  replace(replace(cast(substr(stmt_text,1,200) as varchar(200)), chr(10), ' '), chr(13), ' ') as stmt_text
from
  mon_get_pkg_cache_stmt_diff m,
  (select executable_id, coord_stmt_exec_time
   from mon_get_pkg_cache_stmt_diff
   where coord_stmt_exec_time <> 0
   order by coord_stmt_exec_time desc
   fetch first 100 rows only) c
where
  (total_act_time <> 0 or m.coord_stmt_exec_time <> 0) and num_exec_with_metrics <> 0 and c.executable_id = m.executable_id
order by
  c.coord_stmt_exec_time desc, total_act_time desc, member asc
with UR;

echo ============================================================================================ ;
echo  INF#EXPLN: Statement & plan identifiers - top statements by execution time  ;
echo  To populate the explain tables:  ;
echo    db2 -tvf $HOME/sqllib/misc/explain.ddl  ;
echo    db2 "call explain_from_section(x'<executable id>','M',NULL,0,'<current user>',?,?,?,?,?)  ;
echo ============================================================================================ ;
echo ;

/* IBM_DB2MON */
select
  member,
  executable_id,
  replace(replace(cast(substr(stmt_text,1,200) as varchar(200)), chr(10), ' '), chr(13), ' ') as stmt_text
from
        mon_get_pkg_cache_stmt_diff
where
        coord_stmt_exec_time <> 0
order by
        coord_stmt_exec_time desc
fetch first 100 rows only
with UR;

echo ====================================================== ;
echo  DB#SYSRE: Database system resource usage information  ;
echo ====================================================== ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(os_name,1,8) as varchar(8)) as os,
   cast(substr(host_name,1,16) as varchar(16)) host_name,
   cast(substr(os_version,1,8) as varchar(8)) os_ver,
   cast(substr(os_release,1,8) as varchar(8)) os_rel,
   smallint(cpu_total) cpu_tot,
   smallint(cpu_online) cpu_onl,
   smallint(cpu_configured) cpu_cfg,
   integer(cpu_speed) cpu_speed,
   smallint(cpu_hmt_degree) cpu_hmt,
   integer(memory_total) memory_total,
   integer(memory_free) memory_free,
   decimal(cpu_load_short,6,1) cpu_load_shrt,
   decimal(cpu_load_medium,6,1) cpu_load_med,
   decimal(cpu_load_long,6,1) cpu_load_lng,
   decimal(cpu_usage_total,6,1) cpu_usage_tot,
   integer(swap_pages_in) swap_pages_in,
   integer(swap_pages_out) swap_pages_out
from
   env_get_system_resources_diff
order by
   member
with UR;

echo ========================================== ;
echo  TSP#DSKIO: Disk read and write I/O times  ;
echo ========================================== ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(tbsp_name,1,20) as varchar(20)) as tbsp_name,

   -- Reads

   (pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads) as num_reads,
   case when ((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads)) > 0
      then decimal( pool_read_time / double((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads)), 10, 2 )
      else null
   end as avg_read_time,

   direct_read_reqs,
   case when direct_read_reqs > 0
      then decimal( direct_read_time / direct_read_reqs, 10, 2 )
      else null
   end as avg_drct_read_time,

   -- Writes

   (pool_data_writes + pool_index_writes + pool_xda_writes) as num_writes,
   case when ((pool_data_writes + pool_index_writes + pool_xda_writes)) > 0
      then decimal( pool_write_time / double((pool_data_writes + pool_index_writes + pool_xda_writes)), 10, 2 )
      else null
   end as avg_write_time,

   direct_write_reqs,
   case when direct_write_reqs > 0
      then decimal( direct_write_time / direct_write_reqs, 10, 2 )
      else null
   end as avg_drct_write_time
from
   mon_get_tablespace_diff
where
   ((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads) + direct_read_reqs + (pool_data_writes + pool_index_writes + pool_xda_writes) + direct_write_reqs) >= ts_delta
order by
   ((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads) + direct_read_reqs + (pool_data_writes + pool_index_writes + pool_xda_writes) + direct_write_reqs) desc
with UR;

echo ============================================================ ;
echo  TSP#DSKIOSYNC: Disk read and write I/O times (synchronous)  ;
echo ============================================================ ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(tbsp_name,1,20) as varchar(20)) as tbsp_name,

   -- Reads

   ((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads) - (pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads)) as num_reads,
   case when (((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads) - (pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads))) > 0
      then decimal( (pool_read_time - pool_async_read_time) / double(((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads) - (pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads))), 10, 2 )
      else null
   end as avg_sync_read_time,

   -- Writes

   ((pool_data_writes + pool_index_writes + pool_xda_writes) - (pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes)) as num_writes,
   case when (((pool_data_writes + pool_index_writes + pool_xda_writes) - (pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes))) > 0
      then decimal( (pool_write_time - pool_async_write_time) / double(((pool_data_writes + pool_index_writes + pool_xda_writes) - (pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes))), 10, 2 )
      else null
   end as avg_sync_write_time
from
   mon_get_tablespace_diff
where
   (((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads) - (pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads)) + ((pool_data_writes + pool_index_writes + pool_xda_writes) - (pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes))) >= ts_delta
order by
   (((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads) - (pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads)) + ((pool_data_writes + pool_index_writes + pool_xda_writes) - (pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes))) desc
with UR;

echo ============================================================== ;
echo  TSP#DSKIOASYNC: Disk read and write I/O times (asynchronous)  ;
echo ============================================================== ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(tbsp_name,1,20) as varchar(20)) as tbsp_name,

   -- Reads

   (pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads) as num_reads,
   case when ((pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads)) > 0
      then decimal( pool_async_read_time / double((pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads)), 5, 2 )
      else null
   end as avg_async_read_time,

   -- Writes

   (pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes) as num_writes,
   case when ((pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes)) > 0
      then decimal( pool_async_write_time / double((pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes)), 5, 2 )
      else null
   end as avg_async_write_time
from
   mon_get_tablespace_diff
where
   ((pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads) + (pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes)) >= ts_delta
order by
   ((pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads) + (pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes)) desc
with UR;

echo ========================================================= ;
echo  DB#DLCKS: Deadlocks, lock timeouts and lock escalations  ;
echo ========================================================= ;
echo ;

/* IBM_DB2MON */
select
   member,
   integer(sum(deadlocks)) as deadlocks,
   integer(sum(lock_timeouts)) as lock_timeouts,
   integer(sum(lock_escals)) as lock_escals
from
   mon_get_workload_diff
group by
   member
order by
   member asc
with UR;

echo ======================================== ;
echo  TBL#ROWMC: Various table level metrics  ;
echo ======================================== ;
echo ;

/* IBM_DB2MON */
select
  mgt.member,
  cast(substr(mgt.tabname,1,32) as varchar(32)) as tabname,
  smallint(mgt.data_partition_id) data_part_id,
  smallint(mgt.tbsp_id) tbsp_id,
  sum(mgt.rows_read) rows_read,
  sum(mgt.rows_inserted) rows_inserted,
  sum(mgt.rows_updated) rows_updated,
  sum(mgt.rows_deleted) rows_deleted,
  min(systab.append_mode) append,


  integer(sum(mgt.overflow_accesses))ovfl_accesses,
  integer(sum(mgt.overflow_creates))ovfl_creates,
  integer(sum(mgt.page_reorgs))page_reorgs,
  max(systab.pctpagessaved) pctpagessaved
from
  mon_get_table_diff mgt,
syscat.tables systab
where
  mgt.tabname = systab.tabname and
  mgt.tabschema = systab.tabschema
group by
  mgt.member,mgt.tabname,mgt.tabschema,mgt.data_partition_id,mgt.tbsp_id    -- Roll up over tab_file_id as it's an unimportant difference
having
  sum(rows_read + rows_inserted + rows_updated + rows_deleted + page_reorgs) >= max(ts_delta)
order by
  mgt.tabname asc
with UR;

echo =========================== ;
echo  IDX#OPS: Index operations  ;
echo =========================== ;
echo ;

/* IBM_DB2MON */
select
  mgi.member,
  cast(substr(mgi.tabschema,1,16) as varchar(16)) as tabschema,
  cast(substr(mgi.tabname,1,32) as varchar(32)) as tabname,
  cast(substr(sysidx.indname,1,32) as varchar(32)) as indname,
  mgi.data_partition_id as data_part_id,
  mgi.iid,
  mgi.index_scans,
  mgi.index_only_scans,

  mgi.key_updates,
  mgi.pseudo_deletes,
  mgi.del_keys_cleaned
from
  mon_get_index_diff mgi, syscat.indexes sysidx
where
  mgi.tabschema = sysidx.tabschema and
  mgi.tabname = sysidx.tabname and
  mgi.iid = sysidx.iid and
  (mgi.index_scans + mgi.index_only_scans + mgi.key_updates + mgi.pseudo_deletes
  ) >= ts_delta
order by
  (mgi.index_scans + mgi.index_only_scans + mgi.key_updates + mgi.pseudo_deletes

  ) desc
with UR;

echo =============================== ;
echo  IDX#SPLITS: Index page splits  ;
echo =============================== ;
echo ;

/* IBM_DB2MON */
select
  mgi.member,
  cast(substr(mgi.tabschema,1,16) as varchar(16)) as tabschema,
  cast(substr(mgi.tabname,1,32) as varchar(32)) as tabname,
  cast(substr(sysidx.indname,1,32) as varchar(32)) as indname,
  mgi.data_partition_id as data_part_id,
  mgi.iid,
  decimal((mgi.root_node_splits + mgi.int_node_splits + mgi.boundary_leaf_node_splits + mgi.nonboundary_leaf_node_splits) / float(ts_delta), 10, 1) as splits_per_s,
  mgi.root_node_splits,
  mgi.int_node_splits,
  mgi.boundary_leaf_node_splits,
  mgi.nonboundary_leaf_node_splits
from
  mon_get_index_diff mgi, syscat.indexes sysidx
where
  mgi.tabschema = sysidx.tabschema and
  mgi.tabname = sysidx.tabname and
  mgi.iid = sysidx.iid and
  (mgi.root_node_splits + mgi.int_node_splits + mgi.boundary_leaf_node_splits + mgi.nonboundary_leaf_node_splits) > 0
order by
  (mgi.root_node_splits + mgi.int_node_splits + mgi.boundary_leaf_node_splits + mgi.nonboundary_leaf_node_splits) desc
with UR;

echo ===================================== ;
echo  IDX#PAGEUSE: Index page use metrics  ;
echo ===================================== ;
echo ;

/* IBM_DB2MON */
select
  mgi.member,
  cast(substr(mgi.tabschema,1,16) as varchar(16)) as tabschema,
  cast(substr(mgi.tabname,1,32) as varchar(32)) as tabname,
  cast(substr(sysidx.indname,1,32) as varchar(32)) as indname,
  mgi.data_partition_id as data_part_id,
  mgi.iid,
  mgi.page_allocations,
  mgi.pseudo_empty_pages,
  mgi.empty_pages_reused,
  mgi.empty_pages_deleted,
  mgi.pages_merged
from
  mon_get_index_diff mgi, syscat.indexes sysidx
where
  mgi.tabschema = sysidx.tabschema and
  mgi.tabname = sysidx.tabname and
  mgi.iid = sysidx.iid and
  (mgi.page_allocations + mgi.pseudo_empty_pages + mgi.empty_pages_reused + mgi.empty_pages_deleted + mgi.pages_merged) > 0
order by
  (mgi.page_allocations + mgi.pseudo_empty_pages + mgi.empty_pages_reused + mgi.empty_pages_deleted + mgi.pages_merged) desc
with UR;

echo =========================== ;
echo  DB#SIZE: Size of database  ;
echo =========================== ;
echo ;

/* IBM_DB2MON */
select
  member,
  decimal( sum( double(tbsp_used_pages) * tbsp_page_size ) / 1024 / 1024, 10, 2 ) as db_mb_used
from
  mon_get_tablespace_end
group by
  member
order by
  member asc
with UR;

echo ================================= ;
echo  TSP#SIZE: Tablespace properties  ;
echo ================================= ;
echo ;

/* IBM_DB2MON */
select
  member,
  cast(substr(tbsp_name,1,32) as varchar(32)) as tbsp_name,
  tbsp_id,
  tbsp_page_size,
  tbsp_used_pages,
  decimal( (double(tbsp_used_pages) * tbsp_page_size) / 1024 / 1024, 10, 2 ) as tbsp_mb_used,
  decimal( (double(tbsp_page_top) * tbsp_page_size) / 1024 / 1024, 10, 2) as tbsp_mb_hwm,
  tbsp_extent_size,
  case fs_caching when 2 then 'Default off' when 1 then 'Explicit off' else 'Explicit on' end fs_caching,
  tbsp_prefetch_size
from
  mon_get_tablespace_end
order by
  member asc, tbsp_used_pages desc
with UR;

echo ====================================================== ;
echo  TSP#USAGE: Tablespace usage over monitoring interval  ;
echo ====================================================== ;
echo ;

/* IBM_DB2MON */
select
  member,
  cast(substr(tbsp_name,1,30) as varchar(30)) as tbsp_name,
  tbsp_used_pages,
  decimal( (double(tbsp_used_pages) * tbsp_page_size) / 1024 / 1024, 10, 2 ) as tbsp_mb_used
from
  mon_get_tablespace_diff
where
  tbsp_used_pages > 0
order by
  member asc, tbsp_used_pages desc
with UR;

echo ================================================ ;
echo  BPL#STATS: Bufferpool statistics by tablespace  ;
echo ================================================ ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(tbsp_name,1,20) as varchar(20)) as tbsp_name,

   -- Data pages

   pool_data_l_reads + pool_temp_data_l_reads as data_l_reads,
   pool_data_p_reads + pool_temp_data_p_reads as data_p_reads,
   pool_data_p_reads + pool_temp_data_p_reads - pool_async_data_reads as sync_data_p_reads,
   case when (pool_data_l_reads + pool_temp_data_l_reads) > 1000
      then decimal(float(pool_data_l_reads + pool_temp_data_l_reads - (pool_data_p_reads + pool_temp_data_p_reads - pool_async_data_reads))/(pool_data_l_reads + pool_temp_data_l_reads)*100,5,2)
      else null
   end as data_hr,
   case when (pool_data_l_reads + pool_temp_data_l_reads) > 1000
      then
         decimal((pool_data_lbp_pages_found - pool_async_data_lbp_pages_found) / float(pool_data_l_reads + pool_temp_data_l_reads) * 100, 5, 2)
      else null
   end as data_lbp_hr,
   -- Index pages

   pool_index_l_reads + pool_temp_index_l_reads as index_l_reads,
   pool_index_p_reads + pool_temp_index_p_reads as index_p_reads,
   pool_index_p_reads + pool_temp_index_p_reads - pool_async_index_reads as sync_index_p_reads,
   case when (pool_index_l_reads + pool_temp_index_l_reads) > 1000
      then decimal(float(pool_index_l_reads + pool_temp_index_l_reads - (pool_index_p_reads + pool_temp_index_p_reads - pool_async_index_reads))/(pool_index_l_reads + pool_temp_index_l_reads)*100,5,2)
      else null
   end as index_hr,
   case when (pool_index_l_reads + pool_temp_index_l_reads) > 1000
      then
         decimal((pool_index_lbp_pages_found - pool_async_index_lbp_pages_found ) / float(pool_index_l_reads + pool_temp_index_l_reads) * 100, 5, 2)
      else null
   end as index_lbp_hr
from
   mon_get_tablespace_diff
where
   (pool_data_l_reads + pool_temp_data_l_reads + pool_index_l_reads + pool_temp_index_l_reads + pool_xda_l_reads + pool_temp_xda_l_reads) >= ts_delta
order by
   pool_read_time desc
with UR;


echo ============================================== ;
echo  TSP#PRFST: Tablespace prefetching statistics  ;
echo ============================================== ;
echo ;

/* IBM_DB2MON */
select
  member,
  cast(substr(tbsp_name,1,30) as varchar(30)) as tbsp_name,
  pool_async_data_reads,
  pool_data_p_reads,
  case when pool_data_p_reads > 0 then decimal(pool_async_data_reads / float(pool_data_p_reads) * 100, 5, 2) else null end as pct_data_pftch,
  pool_async_index_reads,
  pool_index_p_reads,
  case when pool_index_p_reads > 0 then decimal(pool_async_index_reads / float(pool_index_p_reads) * 100, 5, 2) else null end as pct_index_pftch,


  unread_prefetch_pages

from
  mon_get_tablespace_diff
where
  (pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads) >= ts_delta
order by
  member asc, (pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads) desc
with UR;

/* IBM_DB2MON */
select
  member,
  cast(substr(tbsp_name,1,30) as varchar(30)) as tbsp_name,
  vectored_ios,
  pages_from_vectored_ios,
  case when vectored_ios > 0 then decimal(pages_from_vectored_ios / float(vectored_ios), 5, 2) else null end as avg_vio_sz,
  block_ios,
  pages_from_block_ios,
  case when block_ios > 0 then decimal(pages_from_block_ios / float(block_ios), 5, 2) else null end as avg_bio_sz
from
  mon_get_tablespace_diff
where
  (vectored_ios + block_ios) >= ts_delta
order by
  member asc, (vectored_ios + block_ios) desc
with UR;

echo ============================================= ;
echo  TSP#BPMAP: Tablespace to bufferpool mapping  ;
echo ============================================= ;
echo ;

/* IBM_DB2MON */
select
   cast(substr(tbspace,1,20) as varchar(20)) as tbsp_name,
   datatype,
   cast(substr(bpname,1,20) as varchar(20)) as bpname
from
  syscat.tablespaces t, syscat.bufferpools b
where
   t.bufferpoolid = b.bufferpoolid
with UR;

echo ============================= ;
echo  BPL#SIZES: Bufferpool sizes  ;
echo ============================= ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(bp_name,1,20) as varchar(20)) as bp_name,
   b.pagesize,
   mgb.bp_cur_buffsz as num_pages,
   decimal(double(b.pagesize) * mgb.bp_cur_buffsz / 1024 / 1024, 10, 2) as size_mb,
   automatic
from
  syscat.bufferpools b, mon_get_bufferpool_diff mgb
where
   b.bpname = mgb.bp_name
order by
   member
with UR;

echo ================================================= ;
echo  BPL#HITRA: Bufferpool data and index hit ratios  ;
echo ================================================= ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(bp_name,1,20) as varchar(20)) as bp_name,
   case when (pool_data_l_reads) > 0
      then
         decimal( ( double(pool_data_lbp_pages_found - pool_async_data_lbp_pages_found ) / (pool_data_l_reads + pool_temp_data_l_reads) ) * 100, 5, 2 )
      else 0
   end as row_data_lbp_hitratio,
   case when (pool_index_l_reads) > 0
      then
         decimal( ( double(pool_index_lbp_pages_found - pool_async_index_lbp_pages_found ) / (pool_index_l_reads + pool_temp_index_l_reads) ) * 100, 5, 2 )
      else 0
   end as index_lbp_hitratio
from
   mon_get_bufferpool_diff
where
   (pool_data_l_reads + pool_temp_data_l_reads + pool_index_l_reads + pool_temp_index_l_reads + pool_xda_l_reads + pool_temp_xda_l_reads) > 0
order by
   (pool_data_l_reads + pool_temp_data_l_reads + pool_index_l_reads + pool_temp_index_l_reads + pool_xda_l_reads + pool_temp_xda_l_reads) desc
with UR;

echo ================================================= ;
echo  BPL#READS: Bufferpool read statistics (overall)  ;
echo ================================================= ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(bp_name,1,20) as varchar(20)) as bp_name,
   pool_data_l_reads,
   pool_data_p_reads,
   pool_index_l_reads,
   pool_index_p_reads,
   pool_read_time,
   case when ((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads)) > 0
      then decimal( pool_read_time / double((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads)), 5, 2 )
      else null
   end as avg_read_time
from
   mon_get_bufferpool_diff
where
   (pool_data_l_reads + pool_temp_data_l_reads + pool_index_l_reads + pool_temp_index_l_reads + pool_xda_l_reads + pool_temp_xda_l_reads) > 0
order by
   (pool_data_l_reads + pool_temp_data_l_reads + pool_index_l_reads + pool_temp_index_l_reads + pool_xda_l_reads + pool_temp_xda_l_reads) desc
with UR;

echo ============================================================ ;
echo  BPL#RDSYNC: Bufferpool read statistics (synchronous reads)  ;
echo ============================================================ ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(bp_name,1,20) as varchar(20)) as bp_name,
   (pool_data_p_reads - pool_async_data_reads) as pool_sync_data_reads,
   (pool_index_p_reads - pool_async_index_reads) as pool_sync_index_reads,
   (pool_read_time - pool_async_read_time) as pool_sync_read_time,
   case when (((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads) - (pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads))) > 0
      then decimal( (pool_read_time - pool_async_read_time) / double(((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads) - (pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads))), 5, 2 )
      else null
   end as avg_sync_read_time
from
   mon_get_bufferpool_diff
where
   ((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads) - (pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads)) > 0
order by
   ((pool_data_p_reads + pool_temp_data_p_reads + pool_index_p_reads + pool_temp_index_p_reads + pool_xda_p_reads + pool_temp_xda_p_reads) - (pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads)) desc
with UR;

echo ============================================================== ;
echo  BPL#RDASYNC: Bufferpool read statistics (asynchronous reads)  ;
echo ============================================================== ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(bp_name,1,20) as varchar(20)) as bp_name,
   pool_async_data_reads,
   pool_async_index_reads,
   pool_async_read_time,
   case when ((pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads)) > 0
      then decimal( pool_async_read_time / double((pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads)), 5, 2 )
      else null
   end as avg_async_read_time
from
   mon_get_bufferpool_diff
where
   (pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads) > 0
order by
   (pool_async_data_reads + pool_async_index_reads + pool_async_xda_reads) desc
with UR;

echo ================================================== ;
echo  BPL#WRITE: Bufferpool write statistics (overall)  ;
echo ================================================== ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(bp_name,1,20) as varchar(20)) as bp_name,
   pool_data_writes,
   pool_index_writes,
   pool_xda_writes,
   pool_write_time,
   case when ((pool_data_writes + pool_index_writes + pool_xda_writes)) > 0
      then decimal( pool_write_time / double((pool_data_writes + pool_index_writes + pool_xda_writes)), 5, 2 )
      else null
   end as avg_write_time
from
   mon_get_bufferpool_diff
where
   (pool_data_writes + pool_index_writes + pool_xda_writes) > 0
order by
   (pool_data_writes + pool_index_writes + pool_xda_writes) desc
with UR;

echo ============================================================== ;
echo  BPL#WRSYNC: Bufferpool write statistics (synchronous writes)  ;
echo ============================================================== ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(bp_name,1,20) as varchar(20)) as bp_name,
   (pool_data_writes - pool_async_data_writes) as pool_sync_data_writes,
   (pool_index_writes - pool_async_index_writes) as pool_sync_index_writes,
   (pool_xda_writes - pool_async_xda_writes) as pool_sync_xda_writes,
   (pool_write_time - pool_async_write_time) as pool_sync_write_time,
   case when (((pool_data_writes + pool_index_writes + pool_xda_writes) - (pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes))) > 0
      then decimal( (pool_write_time - pool_async_write_time) / double(((pool_data_writes + pool_index_writes + pool_xda_writes) - (pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes))), 5, 2 )
      else null
   end as avg_write_time
from
   mon_get_bufferpool_diff
where
   ((pool_data_writes + pool_index_writes + pool_xda_writes) - (pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes)) > 0
order by
   ((pool_data_writes + pool_index_writes + pool_xda_writes) - (pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes)) desc
with UR;

echo ================================================================ ;
echo  BPL#WRASYNC: Bufferpool write statistics (asynchronous writes)  ;
echo ================================================================ ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(bp_name,1,20) as varchar(20)) as bp_name,
   pool_async_data_writes,
   pool_async_index_writes,
   pool_async_xda_writes,
   pool_async_write_time,
   case when ((pool_data_writes + pool_index_writes + pool_xda_writes)) > 0
      then decimal( pool_async_write_time / double((pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes)), 5, 2 )
      else null
   end as avg_write_time
from
   mon_get_bufferpool_diff
where
   (pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes) > 0
order by
   (pool_async_data_writes + pool_async_index_writes + pool_async_xda_writes) desc
with UR;

echo =========================================== ;
echo  CON#WAITT: Wait times at connection level  ;
echo =========================================== ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(application_name,1,20) as varchar(20)) as app_name,
   cast(substr(client_applname,1,20) as varchar(20)) as client_name,
   integer(application_handle) as handle,
   decimal((client_idle_wait_time / double(total_rqst_time)), 10, 2) as idle_rq_ratio,
   decimal((total_wait_time / double(total_rqst_time)) * 100, 5, 2) as pct_rqst_wt,
   decimal((lock_wait_time / double(total_rqst_time)) * 100, 5, 2) as pct_lock,
   decimal((log_disk_wait_time / double(total_rqst_time)) * 100, 5, 2) as pct_lg_dsk,


   decimal((pool_read_time / double(total_rqst_time)) * 100, 5, 2) as pct_pool_r,
   decimal((direct_read_time / float(total_rqst_time)) * 100, 5, 2) as pct_dir_r,
   decimal((direct_write_time / float(total_rqst_time)) * 100, 5, 2) as pct_dir_w,
   decimal(((fcm_recv_wait_time + fcm_send_wait_time) / float(total_rqst_time)) * 100, 5, 2) as pct_fcm,
   decimal(((ida_send_wait_time + ida_recv_wait_time) / double(total_rqst_time)) * 100, 5, 2) as pct_ida
from
   mon_get_connection_diff
where
   total_rqst_time <> 0
order by
   member asc, total_wait_time / double(total_rqst_time) desc
with UR;

echo ================================================ ;
echo  CON#STATS: Various metrics at connection level  ;
echo ================================================ ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(application_name,1,20) as varchar(20)) as app_name,
   cast(substr(client_applname,1,20) as varchar(20)) as client_name,
   integer(application_handle) as handle,
   total_app_commits,
   total_app_rollbacks,
   deadlocks,
   rows_modified,
   rows_read,
   rows_returned,
   total_sorts
from
   mon_get_connection_diff
where
   total_rqst_time <> 0
order by
   member asc, total_wait_time / double(total_rqst_time) desc
with UR;

echo =========================================================================== ;
echo  CON#PAGRW: Physical and logical page reads and writes at connection level  ;
echo =========================================================================== ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(application_name,1,20) as varchar(20)) as app_name,
   cast(substr(client_applname,1,20) as varchar(20)) as client_name,
   integer(application_handle) as handle,
   total_app_commits,
   total_app_rollbacks,
   pool_data_l_reads,
   pool_data_p_reads,
   pool_index_l_reads,
   pool_index_p_reads
from
   mon_get_connection_diff
where
   total_rqst_time <> 0
order by
   member asc, total_wait_time / double(total_rqst_time) desc
with UR;


echo ================================================== ;
echo  CFG#DBM: Database manager configuration settings  ;
echo ================================================== ;
echo ;

/* IBM_DB2MON */
select
   cast(substr(name,1,24) as varchar(24)) as name,
   case when value_flags = 'NONE' then '' else value_flags end flags,
   cast(substr(value,1,64) as varchar(64)) as current_value
from
   dbmcfg_end
order by
   name asc
with UR;

echo ================================ ;
echo  INS#INFO: Instance information  ;
echo ================================ ;
echo ;

/* IBM_DB2MON */
select
   cast(substr(inst_name,1,20) as varchar(20)) as inst_name,
   num_dbpartitions,
   cast(substr(service_level,1,20) as varchar(20)) as service_level,
   cast(substr(bld_level,1,40) as varchar(40)) as bld_level,
   cast(substr(ptf,1,40) as varchar(40)) as ptf
from
   env_inst_info_end
with UR;

echo ================================================= ;
echo  DB#MEMST: Database memory set information @ end  ;
echo ================================================= ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(memory_set_type,1,20) as varchar(20)) as set_type,
   cast(substr(db_name,1,20) as varchar(20)) as dbname,
   decimal( double(memory_set_used) / 1024, 10, 2 ) as memory_set_used_mb,
   decimal( double(memory_set_used_hwm) / 1024, 10, 2 ) as memory_set_used_hwm_mb
from
   mon_get_memory_set_end
order by
   member asc, memory_set_used desc
with UR;

echo ========================================= ;
echo  DB#MEMPL: Memory pool information @ end  ;
echo ========================================= ;
echo ;

/* IBM_DB2MON */
select
   member,
   cast(substr(memory_pool_type,1,20) as varchar(20)) as memory_pool_type,
   cast(substr(db_name,1,20) as varchar(20)) as db_name,
   decimal( double(memory_pool_used) / 1024, 10, 2 ) as memory_pool_used_mb,
   decimal( double(memory_pool_used_hwm) / 1024, 10, 2 ) as memory_pool_used_hwm_mb
from
   mon_get_memory_pool_end
order by
   member asc, memory_pool_used desc
with UR;

echo ================================= ;
echo  DB#SEQIN: Sequences information  ;
echo ================================= ;
echo ;

/* IBM_DB2MON */
select
   cast(substr(seqschema,1,40) as varchar(40)) as seqschema,
   cast(substr(seqname,1,40) as varchar(40)) as seqname,
   seqtype,
   cache,
   order
from
  syscat.sequences
with UR;
/* IBM_DB2MON */ set current schema current user;
