--****************************************************************************
-- (c) Copyright IBM Corp. 2017 All rights reserved.
--
-- The following sample of source code ("Sample") is owned by International
-- Business Machines Corporation or one of its subsidiaries ("IBM") and is
-- copyrighted and licensed, not sold. You may use, copy, modify, and
-- distribute the Sample in any form without payment to IBM, for the purpose of
-- assisting you in the development of your applications.
--
-- The Sample code is provided to you on an "AS IS" basis, without warranty of
-- any kind. IBM HEREBY EXPRESSLY DISCLAIMS ALL WARRANTIES, EITHER EXPRESS OR
-- IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
-- MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE. Some jurisdictions do
-- not allow for the exclusion or limitation of implied warranties, so the above
-- limitations or exclusions may not apply to you. IBM shall not be liable for
-- any damages you suffer as a result of using, copying, modifying or
-- distributing the Sample, even if IBM has been advised of the possibility of
-- such damages.
--*****************************************************************************

echo ********************************************************;
echo                                                         ;
echo  This script was generated                              ;
echo                                                         ;
echo    by db2mon.pl version 1.2.0                           ;
echo                                                         ;
echo    for DB2 version 9.7                                 ;
echo                                                         ;
echo    on Mon Apr 11 00:09:25 2022                          ;
echo                                                         ;
echo    with 30 seconds pause between collections  ;
echo    in db2mon.sql and db2mon_export.sql                  ;
echo    (0 seconds pause means script will wait for <ENTER>) ;
echo                                                         ;
echo  Changes to this script will be overwritten the next    ;
echo  time db2mon.pl is run.                                 ;
echo                                                         ;
echo  1. Change to an empty directory                        ;
echo  2. Connect to database                                 ;
echo  3. Run with CLP as in 'db2 -tvf db2mon_export.sql'     ;
echo                                                         ;
echo  The script will create several IXF files to be         ;
echo  imported with db2mon_import.sql and analyzed with      ;
echo  db2mon_report.sql.  This is often done after the files ;
echo  have been moved to another system for analysis.        ;
echo                                                         ;
echo  Next step after db2mon_export: optionally move IXF     ;
echo  files to a new system for offline analysis, and then   ;
echo  run db2mon_import and then db2mon_report to analyze.   ;
echo                                                         ;
echo ********************************************************;
echo                                                         ;
echo                               ;
echo ***************************** ;
echo Checking db2mon prerequisites ;
echo ***************************** ;
echo                               ;
with /* IBM_DB2MON */
utemp_check as ( 
  select count(*) utemp_count from syscat.tablespaces where datatype = 'U' ),
config_check as (
  select 
    cast(substr(name,1,20) as varchar(20)) name, 
    cast(substr(value,1,20) as varchar(20)) value
  from sysibmadm.dbcfg 
  where dbpartitionnum = current node and
    name in ('mon_req_metrics','mon_act_metrics','mon_obj_metrics') ),
req_check as (
  select value req_value from config_check where name = 'mon_req_metrics' ),
act_check as (
  select value act_value from config_check where name = 'mon_act_metrics' ),
obj_check as (
  select value obj_value from config_check where name = 'mon_obj_metrics' )
select t.prereq "db2mon Prerequisite", t.msg "Status"
from
  utemp_check,
  req_check,
  act_check,
  obj_check,
  table( values
    ( 'MON_REQ_METRICS correct? ', 
       case when req_value in ('BASE','EXTENDED') then 'OK (currently ' || rtrim(req_value) || ')' 
       else '******** Needs to be BASE or EXTENDED to get full data collection' end ),
    ( 'MON_ACT_METRICS correct? ', case when act_value in ('BASE','EXTENDED') then 'OK (currently ' || rtrim(act_value) || ')' 
       else '******** Needs to be BASE or EXTENDED to get full data collection' end ),
    ( 'MON_OBJ_METRICS correct? ', case when obj_value in ('BASE','EXTENDED') then 'OK (currently ' || rtrim(obj_value) || ')' 
       else '******** Needs to be BASE or EXTENDED to get full data collection' end ) ) as t(prereq,msg);

/* IBM_DB2MON */ select cast(substr(current schema,1,24) as varchar(24)) as current_schema from sysibm.sysdummy1;

export to dbmcfg_start.ixf of ixf select current timestamp ts, t.* from sysibmadm.dbmcfg t with UR;
export to env_get_system_resources_start.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (sysproc.env_get_system_resources( ) ) t with UR;
export to env_inst_info_start.ixf of ixf select current timestamp ts, t.* from sysibmadm.env_inst_info t with UR;
export to mon_get_bufferpool_start.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_bufferpool( null, -2) ) t with UR;
export to mon_get_connection_start.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_connection( null, -2) ) t with UR;
export to mon_get_index_start.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_index( null, null, -2) ) t with UR;
export to mon_get_memory_pool_start.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_memory_pool( 'database', null, -2) ) t with UR;
export to mon_get_memory_set_start.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_memory_set( null, null, -2) ) t with UR;
export to mon_get_pkg_cache_stmt_start.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_pkg_cache_stmt( null, null, null, -2) ) t where stmt_text not like 'CALL dbms_alert.sleep%' and stmt_text not like '%/* IBM_DB2MON */%' with UR;
export to mon_get_table_start.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_table( null, null, -2) ) t with UR;
export to mon_get_tablespace_start.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_tablespace( null, -2) ) t where tbsp_used_pages > 1000 with UR;
export to mon_get_workload_start.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_workload( null, -2) ) t with UR;
export to mon_current_sql_plus_start.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, mcs.coord_member,mcs.application_handle,mcs.elapsed_time_sec,mcs.total_cpu_time,mcs.rows_read,mcs.direct_reads,mcs.direct_writes,mcs.stmt_text
from 
  sysibmadm.mon_current_sql mcs 
 where 
  mcs.stmt_text not like '%/* IBM_DB2MON */%' with UR;
export to mon_get_locks_start.ixf of ixf 
   select
   /* IBM_DB2MON */
   distinct
   member,
   application_handle,
   lock_mode,
   lock_status,
   lock_object_type,
   lock_name,
   tbsp_id,
   tab_file_id
from
   table ( mon_get_locks(null,-2) ) with UR;
/* IBM_DB2MON */ call dbms_alert.sleep(30);
/* IBM_DB2MON */ select current timestamp as monitor_end_time from sysibm.sysdummy1;
export to dbmcfg_end.ixf of ixf select current timestamp ts, t.* from sysibmadm.dbmcfg t with UR;
export to env_get_system_resources_end.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (sysproc.env_get_system_resources( ) ) t with UR;
export to env_inst_info_end.ixf of ixf select current timestamp ts, t.* from sysibmadm.env_inst_info t with UR;
export to mon_get_bufferpool_end.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_bufferpool( null, -2) ) t with UR;
export to mon_get_connection_end.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_connection( null, -2) ) t with UR;
export to mon_get_index_end.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_index( null, null, -2) ) t with UR;
export to mon_get_memory_pool_end.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_memory_pool( 'database', null, -2) ) t with UR;
export to mon_get_memory_set_end.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_memory_set( null, null, -2) ) t with UR;
export to mon_get_pkg_cache_stmt_end.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_pkg_cache_stmt( null, null, null, -2) ) t where stmt_text not like 'CALL dbms_alert.sleep%' and stmt_text not like '%/* IBM_DB2MON */%' with UR;
export to mon_get_table_end.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_table( null, null, -2) ) t with UR;
export to mon_get_tablespace_end.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_tablespace( null, -2) ) t where tbsp_used_pages > 1000 with UR;
export to mon_get_workload_end.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, t.* from table (mon_get_workload( null, -2) ) t with UR;
export to mon_current_sql_plus_end.ixf of ixf select /* IBM_DB2MON */ current timestamp ts, mcs.coord_member,mcs.application_handle,mcs.elapsed_time_sec,mcs.total_cpu_time,mcs.rows_read,mcs.direct_reads,mcs.direct_writes,mcs.stmt_text
from 
  sysibmadm.mon_current_sql mcs 
 where 
  mcs.stmt_text not like '%/* IBM_DB2MON */%' with UR;
export to mon_get_locks_end.ixf of ixf 
   select
   /* IBM_DB2MON */
   distinct
   member,
   application_handle,
   lock_mode,
   lock_status,
   lock_object_type,
   lock_name,
   tbsp_id,
   tab_file_id
from
   table ( mon_get_locks(null,-2) ) with UR;
export to syscat_tables.ixf of ixf select * from syscat.tables with UR;
export to syscat_indexes.ixf of ixf select * from syscat.indexes with UR;
export to syscat_tablespaces.ixf of ixf select * from syscat.tablespaces with UR;
export to syscat_bufferpools.ixf of ixf select * from syscat.bufferpools with UR;
export to syscat_sequences.ixf of ixf select * from syscat.sequences with UR;
